      PROGRAM TMO
C      (INPUT,OUTPUT,TAPE5=INPUT,TAPE6=OUTPUT)
C
C
C        THIS IS THE PC-VERSION OF THE OLD PROGRAM TMO WHICH WAS
C        WRITTEN ON CDC MAINFRAME
C        THE PROGRAM WAS TESTED WITH LAHEY-COMPILER.
C        NO IMPROVEMENTS HAVE BEEN IMPLEMENTED.
C
C           F. KOHLBECK
C           ABT. GEOPHYSICS
C           TECHN. UNIVERSITY VIENNA
C           GUSSHAUSSTRASSE 27-29
C           A-1040 WIEN
C           AUSTRIA
C
C
C     PROGRAM TMO CALCULATES UNIT CELL PARAMETERS FROM GIVEN D-VALUES
C        TRIAL AND ERROR CALCULATIONS ARE EXECUTED IN THE ORDER
C        ORTHORHOMBIC - MONOCLINIC - TRICLINIC.
C        IF ONE OF THIS STEPS IS FINISHED OR 500 POSSIBLE SOLUTIONS ARE
C        FOUND THE SOLUTIONS ARE SORTED WITH DESCENDING VOLUME OF CELLS.
C        EQUAL SOLUTIONS ARE SEPARATED AND THE REMAINING ONES ARE
C        REFINED. COMPUTING TIME INCREASES LINEAR WITH THE NUMBER OF
C        SOLUTIONS. THIS IS BECAUSE REFINEMENT IS VERY TIMECONSUMING.
C
C        delete line
C          CALL GETCL(COMLINE)
C        called by Subroutine FSELECT
C        if you dont have an IBM PC
C        This function allows you to specify the input-file on
C        the command line:
C          TMO CU2.DAT
C        calls TMO with datafile CU2.DAT
C
C     THE LAST CARDS OF THE PROGRAM CONTAIN THE DUMMY FUNCTION
C     SUBROUTINE SECOND.IF POSSIBLE THIS FUNCTION SHOULD BE REPLACED BY
C     A FUNCTION SECOND(T) WHICH GIVES THE CURRENT EXECUTION TIME OF THE
C     JOB.SECOND HAS TWO PURPOSES 1. A TIME-LIMIT CAN BE STATED BY THE
C     USER AND RESULTS ARE PRINTED BEFOR BREAKING OFF. 2. AN INTERNAL
C     LOOP IS CONTROLLED AGAINST ENDLESSNES. HOWEWER THIS FUNCTION NEED
C     NOT BE REPLACED.
C
C     1. ONE CARD WITH ANY TITLE
C     FURTHER DATA ARE READ UNDER CONTROL OF NAMELIST
C     THE FIRST CHARACTER IN EACH CARD MUST BE A BLANK
C     2. CARD CONTAINING  $OPA
C        ON IBM MACHINES  $OPA SHOULD BE REPLACED BY  &OPA
C     3. CONSECUTIVE DATA ITEMS SEPARATED BY COMMA,IN THE FOLLOWING FORM
C        X=Y,
C        X STANDS FOR A SYMBOLIC NAME LISTED BELOW
C        Y STANDS FOR THE NUMERIC VALUE OF X
C        THE ORDER OF THE DATA ITEMS IS FREE AND ALL THESE DATA ITEMS
C        CAN BE OMITTED.IN THIS CASE THE DEFAULT VALUES ARE TAKEN.
C
C        SYMBOLIC NAMES, NUMERIC VALUE AND MEANING OF DATA ITEMS.
C        FEHL=GREATEST RELATIVE ERROR OF Q= (DELTA Q)/Q
C             DEFAULT 0.01
C        HM4,KM4,LM4    STARTING VALUES OF INDICES H4,K4,L4
C                       DEFAULT=0,1,1
C        H4MAX,K4MAX,L4MAX=  MAXIMAL VALUES OF  H4,K4,L4
C                            UPPER LIMIT IS  4,4,4
C                            DEFAULT=2,2,2
C        IAMT =0 SUPPRESSES SORTING AND REFINEMENT OF CELLS
C              AIDS ONLY AS A TESTING FACILITY
C        IM=2,3,4,5,6  HIGHEST INDEX OF THE BASIC LINES OF ORTHORMBIC
C                      CELLS. IN MANY CASES IM=2 IS SUFFICIENT
C                      DEFAULT=3
C        IMON=1 SEARCH FOR MONOCLINIC CELLS. AFTER THIS PART IS FINISHED
C               CONTROL IS TRANSFERED TO THE TRICLINIC PROGRAM PART.
C            =2 SEARCH FOR MONOCLINIC CELLS. PROGRAM IS DROPPED  AFTER
C               THIS CALCULATION.
C            =0 MONOCLINIC CALCULATIONS ARE OMITTED.
C               DEFAULT=1
C        IORT=1 SEARCH FOR ORTHORHOMBIC CELLS. AFTER THIS PART IS FINISH
C               CONTROL IS TRANSFERED TO THE MONOCLINIC PROGRAM-PART.
C            =2 SEARCH FOR ORTHORHOMBIC CELLS ONLY. PROGRAM IS DROPPED
C               AFTER EXECUTION OF THIS CALCULATION.
C            =0 ORTHORHOMBIC PROGRAM PART IS OMITTED
C                 DEFAULT=1
C        IQW= LOWEST M20- VALUE WITH PRINTOUT.
C              DEFAULT IQW=I20
C              IF A SOLUTION IS FOUND WITH M20=X AND  IQW<X<I20
C              THEN THE PARAMETERS OF THE UNIT CELL ARE PRINTED.
C              INDEXING OF LINES IS SUPPRESSED.
C        ITA=1  GIVES PRINTOUT OF PROBABILITY VALUES OF POSSIBLE BASIC
C               LINES
C               DEFAULT=0
C        ITEST =1 GIVES OUTPUT OF ALL SOLUTIONS WITHOUT REFINEMENT
C              OF PARAMETERS. AT THIS STAGE M20 VALUES ARE NOT
C              SIGNIFICANT.
C        IUNAB=+1   SEARCH FOR INDEPENDENT BASIC LIST
C             =-1   FIRST LINES ARE TAKEN AS BASIC LINES
C                   DEFAULT=1
C        I20=LOWEST M20 VALUE WITH COMPLETE PRINTOUT OF SOLUTION
C            DEFAULT=7
C        IZE=1,2,3,4  CORRESPOND TO CASES 1,2,3,4 OF SETTING THE INDICES
C                     OF THE FIRST TWO LINES (TRICLINIC CELLS ONLY)
C           =0   ALL VALUES 1,2,3,4  ARE TAKEN ONE AFTER EACH OTHER.
C                DEFAULT=0
C        LUFM=NUMBER OF FAIL LINES AMONG THE FIRST NQ LINES ALLOWED
C             DEFAULT=0
C        MOM= UPPER BOUND OF THE INDICES FOR LINE NO. 3 AND 4  FOR
C             MONOCLINIC LATTICES.
C             DEFAULT=3
C        NLM= (2,3) UPPER BOUND OF THE INDICES FOR LINE NO. 3 AND 4
C            FOR TRICLINIC LATTICES. THE PROBABILITY THAT NLM=3 IS
C            NECESSARY VERY POOR.
C            DEFAULT=2
C        NQ= NUMBER OF D-VALUES USED TO VERIFY THE FOUND CELLS
C            FURTHER VALUES MAY BE PUT IN FOR COMPARISON.
C            IF THERE EXIST UNCERTAIN LINES, THEY SHOULD BE PUT IN
C            AFTER THE FIRST NQ- LINES.
C            DEFAULT=20
C        NZMAX=MAXIMAL NUMBER OF MOLECULES PER UNIT CELL
C        TILI=TIMELIMIT IN SECONDS
C             DEFAULT=7200.
C        V1Z=VOLUME PER FORMULA UNIT OF UNIT CELL.
C            DEFAULT  NO RESTRICTION
C        VD1Z=TOLERANCE ERROR OF V1Z
C             INCLUDES ERROR FROM UNCERTAIN DENSITIES AND FROM ERRORS
C             WITHIN BASELINES.THE LAST ERRORS ARE ABOUT 3*FEHL*V1Z.
C             DEFAULT=1.
C        WLENG=WAVELENGTH  IF  THETA-VALUES ARE REQUESTED ON OUTPUT
C     4. DATA ITEM FOR D-VALUES IN THE FORM D=Y1,Y2,Y3,....
C        Y1,Y2,Y3,....  STANDS FOR THE D-VALUES
C        UNCERTAIN D-VALUES SHOULD BE PUT IN BEHIND THE NQ-TH LINE.
C     5. LAST CARD CONTAINS  $END
C        ON IBM MACHINES   $END SHOULD BE REPLACED BY  &END
C
C
C     SAEMTLICHE DATENKARTEN DUERFEN ERST AB SPALTE ZWEI GELOCHT WERDEN
C     1.  KARTE MIT BELIEBIGEM TEXT
C     2.  KARTE MIT INHALT  $OPA
C         DAS ZEICHEN  $  DARF NICHT IN DER ERSTEN SPALTE STEHEN
C     3.  FOLGEKARTEN  ENTHALTEN DIE NACHSTEHENDEN PARAMETER  IN DER
C           FORM  X=Y,
C           X  BEDEUTET DABEI DEN WORTLAUT DES PARAMETERS ZB.. FEHL
C           Y BEDEUTET DEN INHALT DES PARAMETERS ZB. 0.005
C         DIE REIHENFOLGE DER HIER ANGEFUEHRTEN PARAMETER IST BELIEBIG
C         MIT AUSNAHME DES PARAMETERS  D  NACH WELCHEM DIE D-WERTE
C         FOLGEN KOENNEN ALLE PARAMETER WEGGELASSEN WERDEN. ES WIRD
C         DANN MIT DEN BEI DEFAULT ANGEGEBENEN WERTEN GERECHNET
C         LISTE DER PARAMETER
C         NQ=ZAHL DER D-WERTE ZUR UEBERPRUEFUNG DER GEFUNDENEN ZELLEN
C            DEFAULT=20
C
C         IORT=1    SUCHE NACH ORTHORHOMBISCHEN UND TRIKLINEN ZELLEN
C             =2    NUR ORTHORHOMBISCHE ZELLEN GESUCHT
C             =NEGATIV ODER 0 ... NUR TRIKL. UND MONOKL. ZELLEN GESUCHT
C              DEFAULT=1
C         IMON=1   SUCHE NACH MONOKLINEN UND TRIKLINEN ZELLEN
C             =2   KEINE TRIKLINEN ZELLEN GESUCHT
C             =0   KEINE MONOKLINEN ZELLEN GESUCHT
C              DEFAULT=1
C         IUNAB=POSITIV ... SUCHE NACH UNABHAENGIGEN ANFANGSWERTEN
C              =NEGATIV OD. 0 ... KEINE ABHAENGIGKEIT GESUCHT
C               DEFAULT=1
C         ITER=ZAHL DER NAEHERUNGSSCHRITTE
C              DEFAULT=1
C         IQW=   KLEINSTER M20 WERT MIT LOESUNGSAUSDRUCK
C             DEFAULT=I20
C         I20=KLEINSTER M20 -WERT MIT VOLLSTAENDIGEM LOESUNGSAUSDRUCK
C             DEFAULT=7                                                0
C         LUFM=ZAHL DER PARASITAEREN LINIEN
C              DEFAULT=0
C         MQW=ZAHL DER NACH GROESSE GEORDNETEN Q-WERTE EINER LOESUNG
C             DEFAULT=40
C         FEHL=MAXIMAL ZULAESSIGER FEHLER  DELTA Q/Q
C              DEFAULT=0.01
C         V1Z=VOLUMEN FUER 1 MOLEKUEL/ZELLE
C             NUR WENN BEKANNT
C         VD1Z=MOEGLICHE ABWEICHUNG DES MOLEKUELVOLUMENS VON V1Z
C              DEFAULT=1.
C         NZMAX=MAXIMALE ANZAHL MOLEKUELE/ZELLE
C              DEFAULT=10
C         IZE=1...Q(1) UND Q(2) BEGRENZEN PRIMITIVE BASISFLAECHE
C            =2...Q(1) ENTSPRICHT DEM DOPPELTEN BASISVEKTOR
C            =3...Q(2) ENTSPRICHT DEM DOPPELTEN BASISVEKTOR
C            =4...Q(1) UND Q(2) BEGRENZEN ZWEI PRIMITIVE BASISFLAECHEN
C            =0...ES WERDEN ALLE WERTE IZE=1,2,3,4 DURCHLAUFEN
C             DEFAULT=0
C         NLM=HOECHSTE INDIZIERUNG ...2 ODER 3
C             DEFAULT=2
C
C         HM4,KM4,LM4 .... STARTWERTE FUER H4,K4,L4                    0
C                          DEFAULT=         0, 1, 1
C         H4MAX,K4MAX,L4MAX=    HOECHSTWERTE   FUER H4,K4,L4
C                        MAXIMALWERT= 4,4,4    DEFAULT = 2,2,2
C         ITA=1 BEWIRKT AUSSCHRIFT DER WAHRSCHEINLICHKEITSWERTE AUS UNAB
C             DEFAULT= 0
C         IM=3,4,5,6        HOECHSTE INDIZIERUNGEN FUER DIE BASIS
C                           DER ORTHORHOMBISCHEN ZELLEN
C            DEFAULT=3
C         ITEST=1   AUSSCHRIFT ALLER LOESUNGEN VOR AUSFUEHRUNG DER
C                   OPTIMIERUNG
C                   DEFAULT=0
C         TILI=  ZEITLIMIT IN SEKUNDEN
C                DEFAULT=7200.
C         WLENG= WELLENLAENGE  WENN WINKEL THETA AUSGEGEBEN WERDEN
C     4.  D=D-WERTE  EINZELWERTE DURCH  ,  GETRENNT.
C         DAS ZEICHEN  $  DARF DABEI NICHT IN DER ERSTEN SPALTE STEHEN
C     5.  LETZTE KARTE HAT DEN INHALT  $END
      INTEGER H1,H2,H3,H4,HM4,H2MM,H2MI,H3MI,H4MI,H2MA,H3MA,
     1HE0,HE1,HE2,HD0,HD1,HD2,H4MA,H4MAX
     2,HRE,HSU,HSU2
      LOGICAL LKP,LKN,LHP,LHN,HCH,KCH
      REAL IQW,I20
      DIMENSION FS1(24),FS2(24),FS3(24),FS4(24),
     1FP1(24),FP2(24),FP3(24),FP4(24),FK1(24),FK2(24),FK3(24),FK4(24),
     1DF1(24),DF2(24),DF3(24),DF4(24),DFK1(24),DFK2(24),DFK3(24),
     3DFK4(24),TEXT(20),FEL(50),MFH(8),MFK(8)
     4,VK(10),VG(10),FN1(24),FN2(24),FN3(24),FN4(24)
     5,IQREI(24),DFF1(24),DFF2(24),DFF3(24),DFF4(24),DLM(24),QAN(50)
     6,KIZ(4,4),D(50),S(50),IK(5)
      COMMON FEL,Q(50),NNN,LUFM,FEHLP,ITER/SCHR/TEXT,IQW,I20,MQW
     1,ITEST,QN,WLENG
      COMMON /LSG/AZ(6,500),VVV(500)
      COMMON /OR/IM,NQ
      COMMON /CQS/QS(2)
      COMMON /BEST/WMB
      COMMON /ZEIT/TILL
      COMMON /UNIT/IUR,IUW
      EQUIVALENCE (D(1),VVV(1)),(VVV(51),S(1))
      NAMELIST/OPA/NQ,IORT,IUNAB,LUFM,ITER,IQW,I20,MQW,ITA,ITEST,FEHL
     1,V1Z,VD1Z,NZMAX,IZE,NLM,HM4,KM4,LM4,H4MAX,K4MAX,L4MAX,D,IAMT,IM
     2,IMON,MOM,TILI,WLENG
      IPAR(IZ)=IZ-2*(IZ/2)
      PHI(QZ,PH,PK)=QZ-(A1*PH+A4*PK+A6*VVL)*PH-(A2*PK+ A5*VVL)*PK
     1-A3*VVL**2
      DATA    IORT,IUNAB,ITA/   1,1,0/,V1Z,VD1Z,NZMAX/-1.,1.,10/,IZE,NLM
     2/0,2/,HM4,KM4,LM4/0,1,1/,H4MAX,K4MAX,L4MAX/2,2,2/
      DATA IMON,MOM/1,3/
      DATA KIZ/1,0,0,1,2,0,0,1,1,0,0,2,1,1,-1,1/
      DATA IQREI/6,5,4,6,5,4,3,5,6,3,5,6,4,5,3,4,5,3,3,6,4,3,6,4/
      DATA IK/1,2,3,4,5/
      DATA IAMT/1/
      DATA MFH/3,2,4,3,4,3,6,5/,MFK/1,2,2,3,2,3,3,4/
      DATA  TILI/7200./
      CALL FSELECT(IUR,IUW)
      DO 12 I=1,50
12    D(I)=0.
      WMB=0.
      WLENG=-1.
      LUFM=0
      IM=3
      TRZ1=SECOND(TTZZ)
      NQ=20
      ITER=1
      IQW=-1.
      I20=7
      MQW=40
      ITEST=0
      FEHL=0.01
      READ(IUR,3000)TEXT
      READ(IUR,OPA)
      WRITE(IUW,3014)IORT,IUNAB,IZE,NLM,IM,ITA,HM4,KM4,LM4,H4MAX,K4MAX
     +,L4MAX
      WRITE(6,3016)MOM,ITEST,TILI,IQW,IMON
      IF(IQW.LE.0.)IQW=I20
      WRITE(6,3020)TEXT
      NNN=0
      IZER= 0
      IF(IZE.EQ.0)IZER=1
      IF(IZE.EQ.0)IZE=1
      DO 1 J=1,50
      IF(D(J).LT.0.00001)GO TO 2
1     NNN=NNN+1
2     IF(NQ.GT.NNN)NQ=NNN
      DO 9 I=1,NNN
      S(I)=1./VVV(I)
      Q(I)=S(I)**2
9     QAN(I)=Q(I)
      QS(1)=Q(1)
      QS(2)=Q(2)
      FEHLP=FEHL
      N20=20
      WRITE(6,3005)NQ,LUFM,FEHL
      WRITE(6,3013)IK(1),VVV(1),S(1),Q(1)
      WRITE(6,3006)ITER
      WRITE(6,3013)IK(2),VVV(2),S(2),Q(2)
      WRITE(6,3007)V1Z,VD1Z
      WRITE(6,3013)IK(3),VVV(3),S(3),Q(3)
      WRITE(6,3008)   NZMAX
      WRITE(6,3013)IK(4),VVV(4),S(4),Q(4)
      IS20=I20+0.5
      WRITE(6,3012)MQW,IS20
      WRITE(6,3013)IK(5),VVV(5),S(5),Q(5)
      WRITE(6,3017)
      IF(WLENG.GT.0.)WRITE(6,3018)WLENG
      WRITE(6,3013)IQREI(1),VVV(6),S(6),Q(6)
      WRITE(6,3015)(I,VVV(I),S(I),Q(I),I=7,NNN)
      IF(NNN.LT.N20)N20=NNN
      QN=Q(N20)
      IF(IUNAB.LE.0)GO TO 18
      TILL =TRZ1+0.90*TILI
      CALL  ORDER(QAN,FEHLP,NQ)
18    CONTINUE
      IF(IORT.LE.0)GO TO 3
      CALL ORTHOR(V1Z,VD1Z,NZMAX,ITA)
      IF(IORT.EQ.2)CALL EXIT
3     IF(IMON.LE.0)GO TO 14
      DO 4 I=1,NNN
4     Q(I)=QAN(I)
      CALL MONO (V1Z,VD1Z,NZMAX,NQ,MOM,IUNAB,QN)
      IF(WMB.GT.12..AND.NNN.GE.20)CALL EXIT
      IF(IMON.EQ.2)CALL EXIT
14    CONTINUE
      IF(IUNAB.GT.0)CALL SORT1(NQ,QAN,50,1)
      DO 13 I=1,NNN
13    Q(I)=QAN(I)
      H4MA=H4MAX
      K4MA=K4MAX
      L4MA=L4MAX
      IAZ=0
      IF(IZE.EQ.2.OR.IZE.EQ.4)Q(1)=0.25*QAN(1)
      IF(IZE.EQ.3)Q(1)=QAN(1)
      IF(IZE.GT.2)Q(2)=0.25*QAN(2)
      IF(Q(1).LE.Q(2))GO TO 8
      QQ=Q(1)
      Q(1)=Q(2)
      Q(2)=QQ
8     CONTINUE
      RA=SQRT(Q(2))
      IF(IZE-4)5,6,6
5     IZJ=1
      RA2=0.5*RA
      INN=-3
      IPK=0
      GO TO 7
6     IZJ=2
      RA2=0.6666*RA
      INN=1
      IPK=1
7     CONTINUE
      A=Q(1)
      B=Q(2)
      IF(SQRT(A).GE.RA2)INN=INN+1
      INN=INN+2*NLM
      NLMH=MFH(INN)
      NLMK=MFK(INN)
      IDKG=2*NLMK+1
      VKL=QN**3/1600.
      IF(IZE.EQ.4)VKL=0.25*VKL
      WRITE(6,3001)
      IF(IUNAB)11,11,10
10    WRITE(6,3002)
      CALL UNAB(Q,VVV,FEHLP,IZE,VKL,ITA)
11    CONTINUE
      K4MA=K4MA+NLMK-NLM
      H4MA=H4MA+NLMH-NLM
      IF(K4MA.LT.1)K4MA=1
      IF(H4MA.LT.1)H4MA=1
      WRITE(6,3003)IZE,(KIZ(I,IZE),I=1,4),IZE
      WRITE(6,3009)
      WRITE(6,3010)(KIZ(I,IZE),I=1,4)
      WRITE(6,3011)NLMH,NLMK,NLM,HM4,KM4,LM4,H4MA,K4MA,L4MA
      VM=(1.-FEHLP)/(A*B*Q(4))
      VM=SQRT(VM)
      IF(IZE.EQ.4)VM=VM*0.5
      CALL VGR(QN,V1Z,VD1Z,NZMAX,VM,FEHLP,6,VK,VG,JV)
      AB4=A*B*4.
      APB=A+B
      AA4=4.*A
      DD=2.*(B-A)
      DLMIN=VKL/Q(4)*4.
      A3MIN=VKL/(A*B)
      NU=8
      NUM=NU-1
C      Q1=Q(1)
C      Q2=Q(2)
      Q3=Q(3)
      Q4=Q(4)
      Q5=Q(5)
      Q6=Q(6)
C      Q7=Q(7)
C      Q8=Q(8)
      A1=A
       A2=B
      Q34=Q3-Q4
      Q35=Q3-Q5
      Q36=Q3-Q6
      Q45=Q4-Q5
      Q46=Q4-Q6
      Q56=Q5-Q6
C      NLM2=2*NLM
      ITP=-1
      DO 1200 L4=LM4,L4MA
      L4ZJ=L4*IZJ
      L3MA=L4
      IF(L4.GT.NLM)L3MA=NLM
      N41=L4*L4
      RN4=N41
      VKR=VKL*RN4
      DO 17 J=1,24
      IJ=IQREI(J)
      VKQ=VKR/Q(IJ)
      IF(DLMIN-VKQ)15,16,16
15    DLM(J)=VKQ
      GO TO 17
16    DLM(J)=DLMIN
17    CONTINUE
      DO 1190 K4=KM4,K4MA
      N43=K4*L4
      FK4Q=K4**2
      H4MI=HM4
      IF(IZJ.LE.1)GO TO 20
      IZ=K4+HM4
      IF(IPAR(IZ))19,20,19
19    H4MI=HM4+1
20    DO 1180 H4=H4MI,H4MA,IZJ
      N42=H4*K4
      N44=H4*L4
      FH4Q=H4**2
      DO 1170 L3=1,L3MA
      L3ZJ=L3*IZJ
      N31=L3*L3
      H3MA=NLMH
      IF(L3-L4)23,22,23
22    KMA3=K4
      GO TO 24
23    KMA3=NLMK
      KMI=0
24    DO 1160 IIK3=KMI,KMA3
      K3=IIK3
      IF(L3.EQ.L4.AND.K3.EQ.K4)H3MA=H4
      IF(K4.EQ.0)K3=-K3
      IF(H4.EQ.0)H3=-H3
26    CONTINUE
      N33=K3*L3
      FK3Q=K3*K3
      M213=N31*N43-N41*N33
      VM213=M213
      H3MI=0
      IF(IZJ.LE.1)GO TO 34
      H3MI=IABS(IPAR(K3))
34    DO 1150  IIH3=H3MI,H3MA,IZJ
      H3=IIH3
      IF(H4.EQ.0.AND.K4.NE.0)H3=-H3
36    CONTINUE
      HCH=.NOT.((L3.EQ.L4.AND.K3.EQ.K4.AND.H3.EQ.(-H4)).OR.(K4.EQ.0
     1.AND.K3.EQ.0))
      KCH=.NOT.((L3.EQ.L4.AND.K3.EQ.(-K4).AND.H3.EQ.H4).OR.(K4.EQ
     1.0.AND.K3.EQ.0))
      N32=H3*K3
      N34=H3*L3
      FH3Q=H3*H3
      M212=N31*N42-N41*N32
      M214=N31*N44-N41*N34
      M223=N32*N43-N42*N33
      M224=N32*N44-N42*N34
      M234=N33*N44-N43*N34
      VM212=M212
      VM214=M214
      VM223=M223
      VM224=M224
      VM234=M234
      H2MA=NLMH
      DO 1140 L2=1,L3
      L2ZJ=L2*IZJ
      LSU=L4+L3+L2
      LSUZJ=LSU*IZJ
      N21=L2**2
      K2MM=0
      DO 1130 IIK2=KMI,NLMK
      K2=IIK2
      IF(KCH)GO TO 46
      K2=-K2
      K2MM=K2MM+1
46    CONTINUE
      K2MM=K2MM+1
      IF(L3-L2)53,47,53
47    IF(IIK3-IIK2)1139,48,53
48    IF(K3-K2)52,49,1139
49    IF(H3)50,1139,51
50    H2MA=IIH3
      GO TO 53
51    H2MA=IIH3-1
      GO TO 53
52    IF(L3.EQ.L4.AND.IIK3.EQ.K4)H2MA=H4
53    CONTINUE
      N23=K2*L2
      FK2Q=K2**2
      M313=N21*N43-N41*N23
      M413=N21*N33-N31*N23
      VM313=M313
      VM413=M413
      H2MI=0
      KRE=1
      KSU=K4+K3+K2
      KSU2=IABS(KSU+KSU)
      LKP=IABS(K4-L4).GT.K4MA.OR.IABS(K3-L3).GT.NLMK.OR.IABS(K2-L2)
     1.GT.NLMK
      LKN=IABS(K4+L4).GT.K4MA.OR.IABS(K3+L3).GT.NLMK.OR.IABS(K2+L2)
     1.GT.NLMK
      IF(KSU2.LE.LSU)GOTO54
      IF(KSU)58,54,57
57    IF(LKP)GO TO 54
      GO TO 60
58    IF(LKN)GO TO 54
60    CONTINUE
      KRE=-1
54    CONTINUE
      IF(IZJ.LE.1)GO TO 55
      H2MI=IABS(IPAR(K2))
55    CONTINUE
      H2MM=H2MI-1
      DO 1120 IIH2=H2MI,H2MA,IZJ
      H2=IIH2
      IF(HCH)GO TO 56
      H2=-H2
      H2MM=H2MM+1
56    CONTINUE
      HRE=1
      HSU=H4+H3+H2
      HSU2=IABS(HSU+HSU)
      LHP=IABS(H4-L4ZJ).GT.H4MA.OR.IABS(H3-L3ZJ).GT.NLMH.OR.IABS(H2-
     1L2ZJ).GT.NLMH
      LHN= IABS(H4+L4ZJ).GT.H4MA.OR.IABS(H3+L3ZJ).GT.NLMH.OR.IABS(H2
     1+L2ZJ).GT.NLMH
      IF(HSU2-LSUZJ)180,180,150
150   IF(HSU)160,180,152
152   IF(LHP)GO TO 180
      GO TO 170
160   IF(LHN)GO TO 180
170   HRE=-1
180   CONTINUE
      H2MM=H2MM+1
      N22=H2*K2
      N24=H2*L2
      FH2Q=H2**2
      M312=N21*N42-N41*N22
      M314=N21*N44-N41*N24
      M323=N22*N43-N42*N23
      M324=N22*N44-N42*N24
      M334=N23*N44-N43*N24
      M412=N21*N32-N31*N22
      M414=N21*N34-N31*N24
      M423=N22*N33-N32*N23
      M424=N22*N34-N32*N24
      M434=N23*N34-N33*N24
      VM312=M312
      VM314=M314
      VM323=M323
      VM324=M324
      VM334=M334
      VM412=M412
      VM414=M414
      VM423=M423
      VM424=M424
      VM434=M434
      NG11=N22*M234-N32*M334+N42*M434
      NG12=N21*M234-N31*M334+N41*M434
      NG13=N24*M212-N34*M312+N44*M412
      NG14=N23*M212-N33*M312+N43*M412
      IF(NG11)64,61,64
61    IF(NG12)64,62,64
62    IF(NG13)64,63,64
63    IF(NG14)64,1109,64
64    CONTINUE
      G11=NG11
      G12=NG12
      G13=NG13
      G14=NG14
      IF(NG12.EQ.0.)GO TO 59
      REG=2./G12
      DW1=REG*G11
      DW3=REG*G13
      DW4=-REG*G14
59    CONTINUE
C      F341=0.
      F342=0.
      F343=0.
      F344=0.
C      F241=0.
      F242=0.
      F243=0.
      F244=0.
      F141=G11
      F142=-G12
      F143=G13
      F144=-G14
      F131=G11
      F132=-G12
      F133=G13
      F134=-G14
      SHK12=-M234
      SHK13=M334
      SHK14=-M434
C      SHK22=0.
C      SHK23=0.
C      SHK24=0.
      SHK32=M214
      SHK33=-M314
      SHK34=M414
      SHK42=-M213
      SHK43=M313
      SHK44=-M413
      DE0H=0.
      DBS12=0.
      DBS13=0.
      DBS14=0.
      DBS22=0.
      DBS23=0.
      DBS24=0.
      DBS32=0.
      DBS33=0.
      DBS34=0.
      DBS42=0.
      DBS43=0.
      DBS44=0.
      S2=Q4-A*FH2Q-B*FK2Q
      S3=Q5-A*FH3Q-B*FK3Q
      S4=Q6-A*FH4Q-B*FK4Q
      GA1=-A*G11
      GA3=-A*G13
      GA2=A*G12
      GA4=A*G14
      IF(IPK)65,66,65
65    G4A1=4.*GA1
      G4A2=4.*GA2
      G4A3=4.*GA3
      G4A4=4.*GA4
      G12A1=12.*GA1
      G12A2=12.*GA2
      G12A3=12.*GA3
      G12A4=12.*GA4
      G20A1=20.*GA1
      G20A2=20.*GA2
      G20A3=20.*GA3
      G20A4=20.*GA4
      G28A1=28.*GA1
      G28A2=28.*GA2
      G28A3=28.*GA3
      G28A4=28.*GA4
       G8A1=8.*GA1
      G8A2=8.*GA2
      G8A3=8.*GA3
      G8A4=8.*GA4
      G16A1=16.*GA1
      G16A2=16.*GA2
      G16A3=16.*GA3
      G16A4=16.*GA4
      G24A1=24.*GA1
      G24A2=24.*GA2
      G24A3=24.*GA3
      G24A4=24.*GA4
66    CONTINUE
      G3A1=3.*GA1
      G3A2=3.*GA2
      G3A3=3.*GA3
      G3A4=3.*GA4
      G5A1=5.*GA1
      G5A2=5.*GA2
      G5A3=5.*GA3
      G5A4=5.*GA4
      G7A1=7.*GA1
      G7A2=7.*GA2
      G7A3=7.*GA3
      G7A4=7.*GA4
      SEK=0.
      DBK12=0.
      DBK13=0.
      DBK14=0.
      DBK22=0.
      DBK23=0.
      DBK24=0.
      DBK32=0.
      DBK33=0.
      DBK34=0.
      DBK42=0.
      DBK43=0.
      DBK44=0.
      GB1=-B*G11
      GB2=B*G12
      GB3=-B*G13
      GB4=B*G14
      G3B1=3.*GB1
      G3B2=3.*GB2
      G3B3=3.*GB3
      G3B4=3.*GB4
      G5B1=5.*GB1
      G5B2=5.*GB2
      G5B3=5.*GB3
      G5B4=5.*GB4
      G7B1=7.*GB1
      G7B2=7.*GB2
      G7B3=7.*GB3
      G7B4=7.*GB4
      IE=0
      RO=-1
      Z1=G11*Q3
      Z2=-G12*Q3
      Z3=G13*Q3
      Z4=-G14*Q3
      DEZL=0.
      TRZ2=SECOND(TTZZ)
      IF(IAMT)72,72,67
67    IF(TRZ2-TRZ1-TILI)72,72,68
68    CONTINUE
      IF(IAZ.EQ.0)GO TO 1300
      CALL AMT(IAZ,6)
      IF(IAZ-500)1300,69,69
69    IAZ=0
         GO TO 101
72    RK1=0.
      RK2=0.
      RK3=0.
      RK4=0.
      IW=0
      IPK=IABS(IPK)
      ZK1=Z1+GB1
      ZK2=Z2+GB2
      ZK3=Z3+GB3
      ZK4=Z4+GB4
      ZV1=ZK1
      ZV2=ZK2
      ZV3=ZK3
      ZV4=ZK4
      DO 73 I=1,24
      DFK1(I)=0.
      DFK2(I)=0.
      DFK3(I)=0.
      DFK4(I)=0.
      FK1(I)=0.
      FK2(I)=0.
      FK3(I)=0.
73    FK4(I)=0.
      FK1(6)=-Q34*F141
      FK2(6)=-Q34*F142
      FK3(6)=-Q34*F143
      FK4(6)=-Q34*F144
      FK1(12)=-Q46*F141
      FK2(12)=-Q46*F142
      FK3(12)=-Q46*F143
      FK4(12)=-Q46*F144
      FK1(18)=Q56*F131
      FK2(18)=Q56*F132
      FK3(18)=Q56*F133
      FK4(18)=Q56*F134
      IDV=1
      IF(HRE.LT.0.OR.KRE.LT.0)GO TO 400
      IF(NG12)280,400,280
70    CONTINUE
      FS1(1)=0.
      FS2(1)=-Q56*F342
      FS3(1)=-Q56*F343
      FS4(1)=-Q56*F344
      FS1(2)=0.
      FS2(2)=-Q45*F242
      FS3(2)=-Q45*F243
      FS4(2)=-Q45*F244
      FS1(3)=0.
      FS2(3)=Q46*F342
      FS3(3)=Q46*F343
      FS4(3)=Q46*F344
      FS1(4)=0.
      FS2(4)=-Q56*F242
      FS3(4)=-Q56*F243
      FS4(4)=-Q56*F244
      FS1(5)=0.
      FS2(5)=-Q45*F342
      FS3(5)=-Q45*F343
      FS4(5)=-Q45*F344
      FS1(6)=-Q34*F141
      FS2(6)=-Q34*F142
      FS3(6)=-Q34*F143
      FS4(6)=-Q34*F144
      FS1(7)=0.
      FS2(7)=Q35*F342
      FS3(7)=Q35*F343
      FS4(7)=Q35*F344
      FS1(8)=0.
      FS2(8)=-FS2(4)
      FS3(8)=-FS3(4)
      FS4(8)=-FS4(4)
      FS1(9)=0.
      FS2(9)=-Q36*F342
      FS3(9)=-Q36*F343
      FS4(9)=-Q36*F344
      FS1(10)=0.
      FS2(10)=Q35*F242
      FS3(10)=Q35*F243
      FS4(10)=Q35*F244
      FS1(11)=0.
      FS2(11)=-FS2(1)
      FS3(11)=-FS3(1)
      FS4(11)=-FS4(1)
      FS1(12)=-Q46*F141
      FS2(12)=-Q46*F142
      FS3(12)=-Q46*F143
      FS4(12)=-Q46*F144
      FS1(13)=0.
      FS2(13)=-FS2(5)
      FS3(13)=-FS3(5)
      FS4(13)=-FS4(5)
      FS1(14)=0.
      FS2(14)=-FS2(10)
      FS3(14)=-FS3(10)
      FS4(14)=-FS4(10)
      FS1(15)=0.
      FS2(15)=Q34*F342
      FS3(15)=Q34*F343
      FS4(15)=Q34*F344
      FS1(16)=0.
      FS2(16)=-FS2(2)
      FS3(16)=-FS3(2)
      FS4(16)=-FS4(2)
      FS1(17)=0.
      FS2(17)=-FS2(7)
      FS3(17)=-FS3(7)
      FS4(17)=-FS4(7)
      FS1(18)=Q56*F131
      FS2(18)=Q56*F132
      FS3(18)=Q56*F133
      FS4(18)=Q56*F134
      FS1(19)=0.
      FS2(19)=-FS2(9)
      FS3(19)=-FS3(9)
      FS4(19)=-FS4(9)
      FS1(20)=0.
      FS2(20)=-Q46*F242
      FS3(20)=-Q46*F243
      FS4(20)=-Q46*F244
      FS1(21)=0.
      FS2(21)=-FS2(15)
      FS3(21)=-FS3(15)
      FS4(21)=-FS4(15)
      FS1(22)=0.
      FS2(22)=Q36*F242
      FS3(22)=Q36*F243
      FS4(22)=Q36*F244
      FS1(23)=0.
      FS2(23)=-FS2(3)
      FS3(23)=-FS3(3)
      FS4(23)=-FS4(3)
      DO 75 I=1,23
      FP1(I)=FS1(I)
      FP2(I)=FS2(I)
      FP3(I)=FS3(I)
      FP4(I)=FS4(I)
      FK1(I)=FS1(I)
      FK2(I)=FS2(I)
      FK3(I)=FS3(I)
      FK4(I)=FS4(I)
75    CONTINUE
      IB=1
      ID=1
      IPK=-IABS(IPK)
      NEP=0
      DB12=DBS12
      DB13=DBS13
      DB14=DBS14
      DB22=DBS22
      DB23=DBS23
      DB24=DBS24
      DB32=DBS32
      DB33=DBS33
      DB34=DBS34
      DB42=DBS42
      DB43=DBS43
      DB44=DBS44
      DEH=DE0H
      DBH12=   DB12
      DBH13=DB13
      DBH14=DB14
      DBH22=DB22
      DBH23=DB23
      DBH24=DB24
      DBH32=DB32
      DBH33=DB33
      DBH34=DB34
      DBH42=DB42
       DBH43=DB43
      DBH44=DB44
      DELH=DEH
      DEP=DEZL
      DEN=DEZL
      DEZK=DEZL
      B1=Z1
      B2=Z2
      B3=Z3
      B4=Z4
      ZK1=Z1
      ZK2=Z2
      ZK3=Z3
      ZK4=Z4
      K1=0
80    CONTINUE
C      NPROB=25
      IPK=-IPK
       IF(L2-IE)84,82,84
82    IF(ID-K2MM)86,83,83
83    IW=-1
      IF(H2MM)1109,1109,88
84    IF(IE)86,85,86
85    IW=0
      GO TO 89
86    IW=1
88    CONTINUE
      KS=KSU+K1
      KS2=IABS(KS+KS)
      IF(KS2.LE.LSUK)GO TO 89
      IF(KS)2015,89,2010
2010  IF(LKP.OR.IABS(K1-IE).GT.NLMK)GO TO 89
      GO TO 240
2015  IF(LKN.OR.IABS(K1+IE).GT.NLMK)GO TO 89
      GO TO 240
89    CONTINUE
      IA=1
      H1=0
      IF(IPK)114,90,90
90    CONTINUE
      IF(NEP)92,102,102
92    IF(ABS(DEN)-0.50)107,93,93
93    DENI=1./DEN
      K=0
96    K=K+1
      A3=B1*DENI
      IF(A3-A3MIN)95,95,94
94    A4=B2*DENI
      DL=AB4-A4**2
      IF(DL-DLM(K))95,95,81
81    A5=B3*DENI
      A6=B4*DENI
      GO TO 500
95    CONTINUE
      B1=B1+FN1(K)
      B2=B2+FN2(K)
      B3=B3+FN3(K)
      B4=B4+FN4(K)
      IF(K.LT.24)GO TO 96
      GO TO 107
100   IF(NEP)95,105,105
101   IF(NEP)95,97,97
102   IF(ABS(DEP)-0.50)107,103,103
103   DEPI=1./DEP
      K=0
106   K=K+1
      IDV=IABS(IDV)
      H1=IABS(H1)
      A4=B2*DEPI
      DL=AB4-A4**2
      IF(DL-DLM(K))112,112,87
87    A3=B1*DEPI
      IF(A3-A3MIN)97,97,104
104   A5=B3*DEPI
      A6=B4*DEPI
      GO TO 500
97    CONTINUE
      IF(IDV)112,112,98
98    IDV=-IDV
      A3= (B1+B2*DW1)*DEPI
      IF(A3-A3MIN)112,112,99
99    A5= (B3+B2*DW3)*DEPI
      A6= (B4+B2*DW4)*DEPI
      A4=-B2*DEPI
      H1=-H1
      IF(IZE.EQ.4)DL=DL*0.25
      GO TO 500
105   CONTINUE
      IF(IDV)112,112,111
111   IDV=-IDV
      A3=A3+A4*DW1
      IF(A3-A3MIN)112,112,109
109   A5=A5+A4*DW3
      A6=A6+A4*DW4
      A4=-A4
      H1=-H1
      GO TO 500
112   B1=B1+FP1(K)
      B2=B2+FP2(K)
      B3=B3+FP3(K)
      B4=B4+FP4(K)
      IF(K.LT.24)GO TO 106
107   CONTINUE
      IF(IW)108,113,110
108   IF(IA-H2MM)113,240,240
110   IF(IABS(H1)-NLMH)113,117,240
117   IF(H1)240,240,113
113   CONTINUE
      GO TO (114,220,125,230,130,230,135,230,240),IA
114   CONTINUE
      IA=2
      IB=1
      H1=1
      IF(IZJ-1)120,120,116
116   IF(IPK.LT.0)GO TO 120
      DELH=DELH+DELH
C      IH1=1
      BV1=ZK1+G4A1
      BV2=ZK2+G4A2
      BV3=ZK3+G4A3
      BV4=ZK4+G4A4
      G3A1=G12A1
      G3A2=G12A2
      G3A3=G12A3
      G3A4=G12A4
      G5A1=G20A1
      G5A2=G20A2
      G5A3=G20A3
      G5A4=G20A4
      G7A1=G28A1
      G7A2=G28A2
      G7A3=G28A3
      G7A4=G28A4
118   DB12=DBH12+DBH12
      DB13=DBH13+DBH13
      DB14=DBH14+DBH14
      DB22=DBH22+DBH22
      DB23=DBH23+DBH23
      DB24=DBH24+DBH24
      DB32=DBH32+DBH32
      DB33=DBH33+DBH33
      DB34=DBH34+DBH34
      DB42=DBH42+DBH42
      DB43=DBH43+DBH43
      DB44=DBH44+DBH44
      GO TO (121,121,122),IB
120   CONTINUE
      BV1=ZK1+GA1
      BV2=ZK2+GA2
      BV3=ZK3+GA3
      BV4=ZK4+GA4
121   CONTINUE
      R1=DB12*S2+DB13*S3+DB14*S4
      R2=DB22*S2+DB23*S3+DB24*S4
      R3=DB32*S2+DB33*S3+DB34*S4
      R4=DB42*S2+DB43*S3+DB44*S4
      RV1=R1
      RV2=R2
      RV3=R3
      RV4=R4
122   CONTINUE
      DF341=DB13-DB14
      DF342=DB23-DB24
      DF343=DB33-DB34
      DF344=DB43-DB44
      DF241=DB12-DB14
      DF242=DB22-DB24
      DF243=DB32-DB34
      DF244=DB42-DB44
      DF1(1)=-Q56*DF341
      DF2(1)=-Q56*DF342
      DF3(1)=-Q56*DF343
      DF4(1)=-Q56*DF344
      DF1(2)=-Q45*DF241
      DF2(2)=-Q45*DF242
      DF3(2)=-Q45*DF243
      DF4(2)=-Q45*DF244
      DF1(3)=Q46*DF341
      DF2(3)=Q46*DF342
      DF3(3)=Q46*DF343
      DF4(3)=Q46*DF344
      DF1(4)=-Q56*DF241
      DF2(4)=-Q56*DF242
      DF3(4)=-Q56*DF243
      DF4(4)=-Q56*DF244
      DF1(5)=-Q45*DF341
      DF2(5)=-Q45*DF342
      DF3(5)=-Q45*DF343
      DF4(5)=-Q45*DF344
      DF1(6)=Q34*DB14
      DF2(6)=Q34*DB24
      DF3(6)=Q34*DB34
      DF4(6)=Q34*DB44
      DF1(7)=Q35*DF341
      DF2(7)=Q35*DF342
      DF3(7)=Q35*DF343
      DF4(7)=Q35*DF344
      DF1(8)=-DF1(4)
      DF2(8)=-DF2(4)
      DF3(8)=-DF3(4)
      DF4(8)=-DF4(4)
      DF1(9)=-Q36*DF341
      DF2(9)=-Q36*DF342
      DF3(9)=-Q36*DF343
      DF4(9)=-Q36*DF344
      DF1(10)=Q35*DF241
      DF2(10)=Q35*DF242
      DF3(10)=Q35*DF243
      DF4(10)=Q35*DF244
      DF1(11)=-DF1(1)
      DF2(11)=-DF2(1)
      DF3(11)=-DF3(1)
      DF4(11)=-DF4(1)
      DF1(12)=Q46*DB14
      DF2(12)=Q46*DB24
      DF3(12)=Q46*DB34
      DF4(12)=Q46*DB44
      DF1(13)=-DF1(5)
      DF2(13)=-DF2(5)
      DF3(13)=-DF3(5)
      DF4(13)=-DF4(5)
      DF1(14)=-DF1(10)
      DF2(14)=-DF2(10)
      DF3(14)=-DF3(10)
      DF4(14)=-DF4(10)
      DF1(15)=Q34*DF341
      DF2(15)=Q34*DF342
      DF3(15)=Q34*DF343
      DF4(15)=Q34*DF344
      DF1(16)=-DF1(2)
      DF2(16)=-DF2(2)
      DF3(16)=-DF3(2)
      DF4(16)=-DF4(2)
      DF1(17)=-DF1(7)
      DF2(17)=-DF2(7)
      DF3(17)=-DF3(7)
      DF4(17)=-DF4(7)
      DF1(18)=-Q56*DB13
      DF2(18)=-Q56*DB23
      DF3(18)=-Q56*DB33
      DF4(18)=-Q56*DB43
      DF1(19)=-DF1(9)
      DF2(19)=-DF2(9)
      DF3(19)=-DF3(9)
      DF4(19)=-DF4(9)
      DF1(20)=-Q46*DF241
      DF2(20)=-Q46*DF242
      DF3(20)=-Q46*DF243
      DF4(20)=-Q46*DF244
      DF1(21)=-DF1(15)
      DF2(21)=-DF2(15)
      DF3(21)=-DF3(15)
      DF4(21)=-DF4(15)
      DF1(22)=Q36*DF241
      DF2(22)=Q36*DF242
      DF3(22)=Q36*DF243
      DF4(22)=Q36*DF244
      DF1(23)=-DF1(3)
      DF2(23)=-DF2(3)
      DF3(23)=-DF3(3)
      DF4(23)=-DF4(3)
      GO TO (202,270,128),IB
125   CONTINUE
      IF(IPK.GE.0)GO TO 128
      G3A1=G8A1
      G3A2=G8A2
      G3A3=G8A3
      G3A4=G8A4
      G5A1=G16A1
      G5A2=G16A2
      G5A3=G16A3
      G5A4=G16A4
      G7A1=G24A1
      G7A2=G24A2
      G7A3=G24A3
      G7A4=G24A4
      R1=R1+R1
      R2=R2+R2
      R3=R3+R3
      R4=R4+R4
      IB=3
      GO TO 118
128   CONTINUE
      BV1=BV1+G3A1
      BV2=BV2+G3A2
      BV3=BV3+G3A3
      BV4=BV4+G3A4
      IA=4
      GO TO 200
130   BV1=BV1+G5A1
      BV2=BV2+G5A2
      BV3=BV3+G5A3
      BV4=BV4+G5A4
      IA=6
      GO TO 200
135   BV1=BV1+G7A1
      BV2=BV2+G7A2
      BV3=BV3+G7A3
      BV4=BV4+G7A4
      IA=8
200   CONTINUE
      RV1=RV1+R1
      RV2=RV2+R2
      RV3=RV3+R3
      RV4=RV4+R4
      H1=IABS(H1)+1
202   CONTINUE
      IF(IE.EQ.0)IA=IA+1
      NEP=1
      DEP=DEP+DELH
      B1=BV1+RV1
      B2=BV2+RV2
      B3=BV3+RV3
      B4=BV4+RV4
      DO 205 I=1,23
      FP1(I)=FP1(I)+DF1(I)
      FP2(I)=FP2(I)+DF2(I)
      FP3(I)=FP3(I)+DF3(I)
205   FP4(I)=FP4(I)+DF4(I)
      IF(IPK)213,90,219
213   IF(IA.LE.3)GO TO 90
218   DEP=DEP+DEH
219   H1=H1+1
      GO TO 90
220   IA=3
      H1=-H1
      DEN=DEN-DELH
      B1=BV1-RV1
      B2=BV2-RV2
      B3=BV3-RV3
      B4=BV4-RV4
      DO 222 I=1,24
      FN1(I)=FK1(I)-DF1(I)
      FN2(I)=FK2(I)-DF2(I)
      FN3(I)=FK3(I)-DF3(I)
222   FN4(I)=FK4(I)-DF4(I)
      NEP=-1
      GO TO 90
230   IA=IA+1
      NEP=-1
      H1=-H1
      DEN=DEN-DELH
      B1=BV1-RV1
      B2=BV2-RV2
      B3=BV3-RV3
      B4=BV4-RV4
      DO 232 I=1,23
      FN1(I)=FN1(I)-DF1(I)
      FN2(I)=FN2(I)-DF2(I)
      FN3(I)=FN3(I)-DF3(I)
232   FN4(I)=FN4(I)-DF4(I)
      IF(IPK)233,90,90
233   DEN=DEN-DEH
      GO TO 90
240   CONTINUE
      IF(IW)440,253,248
248   IF(ID-IDKG)253,400,400
253   CONTINUE
      GO TO (265,350,290,350,295,350,300,350,400),ID
265   CONTINUE
      RK1=DBK12*S2+DBK13*S3+DBK14*S4
      RK2=DBK22*S2+DBK23*S3+DBK24*S4
      RK3=DBK32*S2+DBK33*S3+DBK34*S4
      RK4=DBK42*S2+DBK43*S3+DBK44*S4
      ZV1=Z1+GB1
      ZV2=Z2+GB2
      ZV3=Z3+GB3
      ZV4=Z4+GB4
      DB12=DBK12
      DB13=DBK13
      DB14=DBK14
      DB22=DBK22
      DB23=DBK23
      DB24=DBK24
      DB32=DBK32
      DB33=DBK33
      DB34=DBK34
      DB42=DBK42
      DB43=DBK43
      DB44=DBK44
      IB=2
      GO TO 122
270   CONTINUE
      DO 273 I=1,23
      DFK1(I)=DF1(I)
      DFK2(I)=DF2(I)
      DFK3(I)=DF3(I)
      DFK4(I)=DF4(I)
      DFF1(I)=DF1(I)
      DFF2(I)=DF2(I)
      DFF3(I)=DF3(I)
      DFF4(I)=DF4(I)
273   CONTINUE
      ZK1=ZV1+RK1
      ZK2=ZV2+RK2
      ZK3=ZV3+RK3
      ZK4=ZV4+RK4
280   CONTINUE
      DHK12=SHK12
      DHK13=SHK13
      DHK14=SHK14
      DHK32=SHK32
      DHK33=SHK33
      DHK34=SHK34
      DHK42=SHK42
      DHK43=SHK43
      DHK44=SHK44
      DEK=SEK
      DG12=-G12
      RZ1=RK1
      RZ2=RK2
      RZ3=RK3
      RZ4=RK4
      ID=1
      K1=1
      IB=1
      IF(IE)347,349,347
290   ZV1=ZV1+G3B1
      ZV2=ZV2+G3B2
      ZV3=ZV3+G3B3
      ZV4=ZV4+G3B4
      GO TO 340
295   ZV1=ZV1+G5B1
      ZV2=ZV2+G5B2
      ZV3=ZV3+G5B3
      ZV4=ZV4+G5B4
      GO TO 340
300   ZV1=ZV1+G7B1
      ZV2=ZV2+G7B2
      ZV3=ZV3+G7B3
      ZV4=ZV4+G7B4
340   RZ1=RZ1+RK1
      RZ2=RZ2+RK2
      RZ3=RZ3+RK3
      RZ4=RZ4+RK4
      ZK1=ZV1+RZ1
      ZK2=ZV2+RZ2
      ZK3=ZV3+RZ3
      ZK4=ZV4+RZ4
      DHK12=DHK12+SHK12
      DHK13=DHK13+SHK13
      DHK14=DHK14+SHK14
      DHK32=DHK32+SHK32
      DHK33=DHK33+SHK33
      DHK34=DHK34+SHK34
      DHK42=DHK42+SHK42
      DHK43=DHK43+SHK43
      DHK44=DHK44+SHK44
      DEK=DEK+SEK
      DG12=DG12-G12
      K1=IABS(K1)+1
      IF(IE)345,349,345
345   CONTINUE
      DO 346 I=1,23
      DFK1(I)=DFK1(I)+DFF1(I)
      DFK2(I)=DFK2(I)+DFF2(I)
      DFK3(I)=DFK3(I)+DFF3(I)
      DFK4(I)=DFK4(I)+DFF4(I)
346   CONTINUE
347   DO 348 I=1,23
      FK1(I)=FS1(I)+DFK1(I)
      FK2(I)=FS2(I)+DFK2(I)
      FK3(I)=FS3(I)+DFK3(I)
      FK4(I)=FS4(I)+DFK4(I)
348   CONTINUE
349   CONTINUE
      DEZK=DEZL+DEK
      DBH12=DBS12+DHK12
      DBH13=DBS13+DHK13
      DBH14=DBS14+DHK14
      DBH22=DBS22
      DBH23=DBS23
      DBH24=DBS24
      DBH32=DBS32+DHK32
      DBH33=DBS33+DHK33
      DBH34=DBS34+DHK34
      DBH42=DBS42+DHK42
      DBH43=DBS43+DHK43
      DBH44=DBS44+DHK44
      DEH=DE0H+DG12
      GO TO 370
350   CONTINUE
      IPK=-IPK
      ZK1=ZV1-RZ1
      ZK2=ZV2-RZ2
      ZK3=ZV3-RZ3
      ZK4=ZV4-RZ4
      K1=-K1
      DO 352 I=1,23
      FK1(I)=FS1(I)-DFK1(I)
      FK2(I)=FS2(I)-DFK2(I)
      FK3(I)=FS3(I)-DFK3(I)
352   FK4(I)=FS4(I)-DFK4(I)
      DBH12=DBS12-DHK12
      DBH13=DBS13-DHK13
      DBH14=DBS14-DHK14
      DBH22=DBS22
      DBH23=DBS23
      DBH24=DBS24
      DBH32=DBS32-DHK32
      DBH33=DBS33-DHK33
      DBH34=DBS34-DHK34
      DBH42=DBS42-DHK42
      DBH43=DBS43-DHK43
      DBH44=DBS44-DHK44
      DEZK=DEZL-DEK
      DEH=DE0H-DG12
370   CONTINUE
      DB12=DBH12
      DB13=DBH13
      DB14=DBH14
      DB22=DBH22
      DB23=DBH23
      DB24=DBH24
      DB32=DBH32
      DB33=DBH33
      DB34=DBH34
      DB42=DBH42
      DB43=DBH43
      DB44=DBH44
      DO 372 I=1,23
      FP1(I)=FK1(I)
      FP2(I)=FK2(I)
      FP3(I)=FK3(I)
372   FP4(I)=FK4(I)
      B1=ZK1
      B2=ZK2
      B3=ZK3
      B4=ZK4
      DEP=DEZK
      DEN=DEZK
      DELH=DEH
      NEP=0
      ID=ID+1
      IF(IE)80,375,80
375   ID=ID+1
      GO TO 80
400   CONTINUE
      IDV=0
      IE=IE+1
      IF(IE-L2)430,420,440
420   IF(K2.EQ.0.AND.H2.EQ.0)GO TO 440
430   CONTINUE
       LSUK=LSU+IE
C      L1ZJ=IE*IZJ
C      LSUH=LSUZJ+L1ZJ
      RO=RO+2.
      DBL22=RO*VM234
      DBL23=-RO*VM334
      DBL24=RO*VM434
      DBL32=-RO*VM224
      DBL33=RO*VM324
      DBL34=-RO*VM424
      DBL42=RO*VM223
      DBL43=-RO*VM323
      DBL44=RO*VM423
      ROG=RO*G11
      DEZL=DEZL+ROG
      DBK12=DBK12+VM224
      DBK13=DBK13-VM324
      DBK14=DBK14+VM424
      DBK22=DBK22-VM214
      DBK23=DBK23+VM314
      DBK24=DBK24-VM414
      DBK42=DBK42+VM212
      DBK43=DBK43-VM312
      DBK44=DBK44+VM412
      DBS12=DBS12-VM223
      DBS13=DBS13+VM323
      DBS14=DBS14-VM423
      DBS22=DBS22+VM213
      DBS23=DBS23-VM313
      DBS24=DBS24+VM413
      DBS32=DBS32-VM212
      DBS33=DBS33+VM312
      DBS34=DBS34-VM412
      DE0H=DE0H-G14
      SEK=SEK+G13
      F342=DBL23-DBL24+F342
      F343=DBL33-DBL34+F343
      F344=DBL43-DBL44+F344
      F242=DBL22-DBL24+F242
      F243=DBL32-DBL34+F243
      F244=DBL42-DBL44+F244
      F142=F142-DBL24
      F143=F143-DBL34
      F144=F144-DBL44
      F132=F132-DBL23
      F133=F133-DBL33
      F134=F134-DBL43
      Z2=Z2+DBL22*S2+DBL23*S3+DBL24*S4
      Z3=Z3+DBL32*S2+DBL33*S3+DBL34*S4
      Z4=Z4+DBL42*S2+DBL43*S3+DBL44*S4
      GO TO 70
440   CONTINUE
      GO TO 1109
500   CONTINUE
      VL=A4*A5*A6-A*A5*A5-B*A6*A6
      VOL=(DL*A3+VL)*0.25
      IF(VOL)100,100,511
511   CONTINUE
      IF(IZE.EQ.4)VOL=4.*VOL
      DO 513 I=1,JV
      IF(VOL-VG(I))512,512,513
512    IF(VOL-VK(I))100,514,514
513   CONTINUE
      GO TO 100
514   CONTINUE
      IF(IZE-4)509,502,509
502   IF(A4)503,504,504
503   A4=-A4
      A6=-A6
504   A1=APB-A4
      A2=APB+A4
      E=A5
      IF(A2-AA4)505,505,506
505   A4=DD
      A5=E+A6
      A6=E-A6
      GO TO 507
506   A2=AA4
      A4=A4+A4-AA4
      A5=A6+A6
      A6=E-A6
507   DL=4.*DL
      VL=4.*VL
509   CONTINUE
      LUF=0
      TH=-2.*A1
      TK=-2.*A2
      THK=-A4
      DO 760 IQ=7,NQ
      QQ=Q(IQ)
      FEHL=FEHLP*QQ
      QQF=QQ+FEHL
      ZZ2=QQF/(A3+VL/DL)
      IF(ZZ2-36.)519,516,516
519   LMAX=SQRT(ZZ2)
      GO TO 517
516   LMAX=6
517   CONTINUE
      L=-1
524   L=L+1
      REST0= SECOND(REST)
      VVL=L
      VDL=VVL/DL
      D0=QQ-A3*VVL**2
      TD0H=-A1-A6*VVL
      TD0K=-A2-A5*VVL
      HD0=0
      KD0=0
      IF(ABS(D0)-FEHL)750,750,520
520   IF(D0)530,530,521
521   E0=D0+TD0H
      TE0H=TD0H+TH
      TE0K=TD0K+THK
      HE0=HD0+1
      KE0=KD0
      IF(ABS(E0)-FEHL)750,750,522
522   IF(E0)540,540,523
523   D0=E0
      TD0H=TE0H
      TD0K=TE0K
      HD0=HE0
      IF(HD0-NU)521,525,525
525   D1=D0
      TD1H=TD0H
      TD1K=TD0K
      HD1=HD0
      KD1=KD0
      HE1=NU
      KE1=KD1+1
      IG=1
      HE0=NU
      HD0=NU
      KE0=KD0+1
      IF(KD0.EQ.(-NU))KD0=-NUM
      IF(L)605,527,605
527   HD0=-NU
      HE0=-NU
      KE0=-1
      GO TO 605
530   SHD0=(A4*A5-2.*A2*A6)*VDL
      SKD0=(A4*A6-2.*A1*A5)*VDL
      HD0=ABS(SHD0)+0.5
      KD0=ABS(SKD0)+0.5
      IF(SKD0.LT.0.)KD0=-KD0
      IF(SHD0.LT.0.)HD0=-HD0
      IF(HD0.GT.NUM)HD0=NUM
      IF(HD0.LT.(-NU))HD0=-NU
      IF(KD0.GT.NU)KD0=NU
      IF(KD0.LT.(-NU))KD0=-NU
      VH0=HD0
      VK0=KD0
      D0=D0-(A1*VH0+A4*VK0+A6*VVL)*VH0-(A2*VK0+A5*VVL)*VK0
      IF(ABS(D0)-FEHL)750,750,531
531   IF(D0)534,750,532
532   TD0H=-(2.*VH0+1.)*A1-A4*VK0-A6*VVL
      TD0K=-(2.*VK0+1.)*A2-A4*VH0-A5*VVL
      GO TO 521
534   IIK=1
      VK00=VK0
535   SH1=-(A4*VK0+A6*VVL)/(2.*A1)
      D1=PHI(QQF,SH1,VK0)
      IF(D1)539,536,536
536   HD0=SH1+100.5
      HD0=HD0-100
      VH0=HD0
      D0=PHI(QQ,VH0,VK0)
      IF(ABS(D0)-FEHL)750,750,537
537   IF(D0.LE.0)GO TO 538
      IF(IABS(HD0).GT.NU.OR.IABS(KD0).GT.NU)GO TO 750
      GO TO 532
538   VK0=VK0+IIK
      GO TO 535
539   IF(IIK.LT.0)GO TO 701
      IIK=-1
      VK0=VK00-1
      GO TO 535
540   CONTINUE
      IG=1
      D1=D0
      TD1H=TD0H
      TD1K=TD0K
      HD1=HD0
      KD1=KD0
      E1=E0
      TE1H=TE0H
      TE1K=TE0K
      HE1=HE0
      KE1=KE0
      D2=E1+TE1K
      TD2H=TE1H+THK
      TD2K=TE1K+TK
      HD2=HE1
      KD2=KE1+1
      IF(L)545,542,545
542   HD0=-HD0
      KD0=-KD0
      HE0=-HE0
      KE0=-KE0
545   CONTINUE
551   CONTINUE
      REST1= SECOND(REST)
      IF(REST1-REST0-0.5)548,548,690
548   CONTINUE
      IF(ABS(D2)-FEHL)750,750,552
552   IF(D2)570,553,553
553   D1=D2
      TD1K=TD2K
      TD1H=TD2H
      IF(IG)560,560,554
554   KD1=KD2
      IF(HD1-HE1)555,690,557
555   HD1=HD2
      GO TO 600
557   HD1=HD2
      GO TO 620
560   HD1=HD2
      IF(KD1-KE1)561,690,563
561   KD1=KD2
      GO TO 640
563   KD1=KD2
      GO TO 660
570   CONTINUE
      IF(IG)575,690,571
571   HE2=HD1
      KE2=KD2
      IF(KE2-KD1)572,690,573
572   TE2H=TD1H-THK
      TE2K=TD1K-TK
      E2=D1-TE2K
      GO TO 580
573   E2=D1+TD1K
      TE2H=TD1H+THK
      TE2K=TD1K+TK
      GO TO 580
575   HE2=HD2
      KE2=KD1
      IF(HE2-HD1)576,690,577
576   TE2H=TD1H-TH
      TE2K=TD1K-THK
      E2=D1-TE2H
      GO TO 580
577   E2=D1+TD1H
      TE2H=TD1H+TH
      TE2K=TD1K+THK
580   CONTINUE
      IF(ABS(E2).LE.FEHL)GO TO 750
      IF(E2)581,690,590
581   E1=E2
      TE1H=TE2H
      TE1K=TE2K
      IF(IG)582,690,586
582   HE1=HE2
      IF(KD1-KE1)583,690,584
583   KE1=KE2
      GO TO 660
584   KE1=KE2
      GO TO 640
586   KE1=KE2
      IF(HD1-HE1)587,690,588
587   HE1=HE2
      GO TO 620
588   HE1=HE2
      GO TO 600
590   D1=E2
      TD1H=TE2H
      TD1K=TE2K
      HD1=HE2
      KD1=KE2
      E1=D2
      TE1H=TD2H
      TE1K=TD2K
      IG=-IG
      IF(IG)591,690,595
591   HE1=HD2
      IF(KD2-KE1)592,690,593
592   KE1=KD2
      GO TO 660
593   KE1=KD2
      GO TO 640
595   KE1=KD2
      IF(HD2-HE1)596,690,597
596   HE1=HD2
      GO TO 620
597   HE1=HD2
      GO TO 600
600   CONTINUE
      IF(HE1.NE.HE0)GO TO 602
      IF(KE1.NE.KE0)GO TO 602
      IF(KD1.NE.KD0)GO TO 602
      IF(HD1-HD0)602,699,602
602   CONTINUE
      D2=E1+TE1H
      TD2H=TE1H+TH
      TD2K=TE1K+THK
      HD2=HE1+1
      IF(HD2-NU)603,603,604
603   KD2=KE1
      GO TO 680
604   CONTINUE
      REST1= SECOND(REST)
      IF((REST1-REST0).GT.0.5)GO TO 690
      IF(KD1.EQ.KD0.AND.HD1.EQ.HD0)GO TO 699
      IF(KD1-KE1)615,690,611
611   KE1=KD1+1
      IF(HE1.NE.HE0)GO TO 612
      IF(KE1-KE0)612,699,612
605   KE1=KD1+1
612   IF(KE1-NU)606,606,630
606   E1=D1+TD1K
      TE1K=TD1K+TK
      TE1H=TD1H+THK
      IF(HE1.NE.HD0)GO TO 607
      IF(KE1-KD0)607,699,607
607   IF(ABS(E1)-FEHL)750,750,608
608   IF(E1)610,750,609
609   KD1=KE1
      D1=E1
      TD1K=TE1K
      TD1H=TE1H
      GO TO 605
610   IF(HD1)602,690,622
615   KE1=KD1-1
      IF(KE1+NU)630,616,616
616   TE1K=TD1K-TK
      TE1H=TD1H-THK
      E1=D1-TE1K
      IF(HE1.NE.HD0)GO TO 617
      IF(KE1-KD0)617,699,617
617   IF(ABS(E1)-FEHL)750,750,619
619   IF(E1)610,690,618
618   KD1=KE1
      D1=E1
      TD1K=TE1K
      TD1H=TE1H
      GO TO 615
620   CONTINUE
      IF(HE1.NE.HE0)GO TO 622
      IF(KE1.NE.KE0)GO TO 622
      IF(HD1.NE.HD0)GO TO 622
      IF(KD1-KD0)622,699,622
622   CONTINUE
      TD2H=TE1H-TH
      TD2K=TE1K-THK
      D2=E1-TD2H
      HD2=HE1-1
      IF(HD2+NU)604,623,623
623   KD2=KE1
      GO TO 680
630   CONTINUE
      IG=-IG
      KE1=KD1
      IF(HD1)645,690,655
640   CONTINUE
      IF(HE1.NE.HE0)GO TO 642
      IF(HD1.NE.HD0)GO TO 642
      IF(KE1.NE.KE0)GO TO 642
      IF(KD1-KD0)642,699,642
642   CONTINUE
      D2=E1+TE1K
      TD2H=TE1H+THK
      TD2K=TE1K+TK
      HD2=HE1
      KD2=KE1+1
      IF(KD2-NU)680,680,644
644   IF(HD1-HE1)655,690,645
645   HE1=HD1+1
      IF(HE1.NE.HE0)GO TO 647
      IF(KE1-KE0)647,699,647
647   CONTINUE
      IF(HE1-NU)646,646,670
646   E1=D1+TD1H
      TE1H=TD1H+TH
      TE1K=TD1K+THK
      IF(ABS(E1)-FEHL)750,750,648
648   IF(E1)650,750,649
649   HD1=HE1
      D1=E1
      TD1H=TE1H
      TD1K=TE1K
      GO TO 645
650   IF(KD1)642,690,662
655   HE1=HD1-1
      IF(HE1+NU)670,656,656
656   TE1H=TD1H-TH
      TE1K=TD1K-THK
      E1=D1-TE1H
      IF(HE1.NE.HE0)GO TO 657
      IF(KE1-KE0)657,699,657
657   IF(ABS(E1)-FEHL)750,750,659
659   IF(E1)650,690,658
658   HD1=HE1
      D1=E1
      TD1H=TE1H
      TD1K=TE1K
      GO TO 655
660   CONTINUE
      IF(HE1.NE.HE0)GO TO 662
      IF(KE1.NE.KE0)GO TO 662
      IF(HD1.NE.HD0)GO TO 662
      IF(KD1-KD0)662,699,662
662   TD2H=TE1H-THK
      TD2K=TE1K-TK
      D2=E1-TD2K
      HD2=HE1
      KD2=KE1-1
      IF(KD2+NU)644,680,680
670   IG=-IG
      HE1=HD1
      IF(KD1)605,690,615
680   IG=-IG
      GO TO 551
690   CONTINUE
      WRITE(6,3031)HD0,KD0,HE0,KE0,D0,E0,L,LMAX
      WRITE(6,3032)HD1,KD1,HE1,KE1,D1,E1,IG
      WRITE(6,3033)HD2,KD2,HE2,KE2,D2,E2,IG
      WRITE(6,3034)A1,A2,A3,A4,A5,A6,QQ
699   CONTINUE
      IF(L.LT.LMAX)GO TO 524
701   CONTINUE
      LUF=LUF+1
      IF(LUF-LUFM)750,750,101
750   CONTINUE
760   CONTINUE
      IAZ=IAZ+1
      AZ(1,IAZ)=A1
      AZ(2,IAZ)=A2
      AZ(3,IAZ)=A3
      AZ(4,IAZ)=A4
      AZ(5,IAZ)=A5
      AZ(6,IAZ)=A6
      VVV(IAZ)=VOL
      IF(IAZ.EQ.500)GO TO 68
      GO TO 101
1109  CONTINUE
      IF(H2)1120,1120,1115
1115  H2=-H2
      GO TO 56
C1119  CONTINUE
1120  CONTINUE
      IF(K2)1130,1130,1125
1125  K2=-K2
      GO TO 46
1130  CONTINUE
 1139  CONTINUE
1140  CONTINUE
      IF(H3.LE.0)GO TO 1150
      H3=-H3
      GO TO 36
1150  CONTINUE
      IF(K3.LE.0)GO TO 1160
      K3=-K3
      GO TO 26
1160  CONTINUE
1170  CONTINUE
1180  CONTINUE
      HM4=0
1190  CONTINUE
      KM4=0
1200  CONTINUE
      ITP=1
      IF(IAZ.EQ.0)WRITE(6,3024)
      CALL AMT(IAZ,6)
1300  CONTINUE
      IF(ITP.LE.0)WRITE(6,3021)H4,K4,L4,IZE
      IF(IZER)2000,2000,1500
1500  IZE=IZE+1
      IF(WMB.GE.12..AND.NNN.GE.20)CALL EXIT
      IF(IZE-4)14,14,2000
2000  CONTINUE
3000  FORMAT(20A4)
3001   FORMAT(//42X,26HSEARCH FOR TRICLINIC CELLS/42X,26(1H*)//)
3002  FORMAT(1H0,28HSEARCH FOR PROPER BASE LINES/)
3003  FORMAT(/5H0CASE,I2,3H  (,2I1,8H0) AND (,2I1,35H0) FOR THE FIRST TW
     +O D-VALUES (IZE=,I1,1H))
3004  FORMAT(1X,F15.3,6H .....,F9.3)
3005  FORMAT(///,1H0,47HNUMBER OF D-VALUES USED TO VERIFY THE UNIT CELL,
     110(1H.),I3,15X,20HINPUT D-VALUES (OBS)/   34H NUMBER OF INCORRECT
     2LINES ALLOWED,25(1H.),I2,24X,1HD,8X,3H1/D,9X,1HQ/  25H ALLOWED ERR
     3OR (QO-QC)/QO,30(1H.),F6.3)
3006  FORMAT(22H NUMBER OF REFINEMENTS,37(1H.),I2)
3007  FORMAT(1X,23HVOLUME PER FORMULA UNIT,19(1H.),F8.3,3H +-,F7.3)
3008  FORMAT(49H MAXIMUM NUMBER OF FORMULA UNITS PER CELL ALLOWED,
     110(1H.),I2)
3009  FORMAT(1H0,21HINDEXING OF BASELINES/90X,7H/H/K/L/)
3010  FORMAT(3X,9HLINE 1   ,76(1H.),2X,2I2,2H 0/3X,9HLINE 2   ,76(1H.)
     +,2X,2I2,2H 0)
3011  FORMAT(3X,25HLINES 3,4,5,6   WITH L=0 ,49(1H.),19H    UP TO     4
     14 0/19X,23HWITH L GREATER THAN 0  ,35(1H.),13H    UP TO    ,3I2/19
     2X,34HONE OF THIS LINES IS INDEXED FROM ,16(1H.),3I2,6X
     3,5HUP TO ,4X,3I2)
3012  FORMAT(1H ,I2,48H Q-VALUES ARE PRINTED OUT IF M20 IS GREATER THAN,
     + 8(1H.),I2)
3013  FORMAT(1H+,75X,I3,F9.3,2F11.5)
3014  FORMAT(///16H0INPUT PARAMETER/6H IORT=,I2,9H   IUNAB=,I2,6H  IZE=
     +,I1,5X,4HNLM=,I1,5X,3HIM=,I1,6X,4HITA=,I1,5X,4HHM4=,I1,5X,4HKM4=
     +,I1,5X,4HLM4=,I1,5X,6HH4MAX=,I1,9H   K4MAX=,I1,9H   L4MAX=,I1)
3015  FORMAT(1H ,75X,I3,F9.3,2F11.5)
3016  FORMAT(1X,4HMOM=,I3,9H   ITEST=,I2,7H  TILI=,F8.2,7X,4HIQW=,F4.1,
     1  7H  IMON=,I2)
3017  FORMAT(1H  ,10HWAVELENGTH,40(1H.))
3018  FORMAT(1H+,50X,F10.6)
3020  FORMAT(1H1,20A4)
3021  FORMAT(//62H0CALCULATION NOT FINISHED.CONTINUE WITH IMPUT PARAMETE
     +RS  HM4=,I1,6H, KM4=,I1,6H, LM4=,I1,10H, AND IZE=,I1,16H, IF NO SO
     +LUTION/42H OR NO ACCEPTABLE SOLUTION IS PRINTED OUT.)
3022  FORMAT(1H0,14HVOLUME RANGES )
3023  FORMAT(1H0,29HREMAINING JOBTIME IN SECONDS ,I10/)
3024  FORMAT(1H0,' NO SOLUTION FOUND')
3031  FORMAT(1X,4HHD0=,I2,5X,4HKD0=,I2,5X,4HHE0=,I2,5X,4HKE0=,I2,10X,
     13HD0=,E14.5,5X,3HE0=,E14.5,10X,2HL=,I2,5X,5HLMAX=,I2)
3032  FORMAT(1X,4HHD1=,I2,5X,4HKD1=,I2,5X,4HHE1=,I2,5X,4HKE1=,I2,10X,
     13HD1=,E14.5,5X,3HE1=,E14.5,10X,3HIG=,I2)
3033  FORMAT(1X,4HHD2=,I2,5X,4HKD2=,I2,5X,4HHE2=,I2,5X,4HKE2=,I2,10X,
     13HD2=,E14.5,5X,3HE2=,E14.5,10X,3HIG=,I2)
3034  FORMAT(1H0,3G15.5,2X,3G15.5,5X,3HQQ=,F10.6)
3060  FORMAT(1X,4HIZA=,I9,10X,4HIZB=,I8,10X,4HIZC=,I5)
      CALL EXIT
      END
      SUBROUTINE AMT(IAZ,IOR)
      DIMENSION AZ(6,500),VVV(500),AR(9)
      COMMON /LSG/AZ,VVV
      IF(IAZ.LE.0)RETURN
      IF(IOR-3)2,2,4
2     DO 3 I=1,IAZ
      A1=AMIN1(AZ(1,I),AZ(2,I))
      A2=AMAX1(AZ(1,I),AZ(2,I))
      A3=AMAX1(A1,AZ(3,I))
      AZ(1,I)=AMIN1(A1,AZ(3,I))
      AZ(2,I)=AMIN1(A2,A3)
      AZ(3,I)=AMAX1(A2,A3)
3     CONTINUE
      GO TO 10
4     CONTINUE
      DO 5 I=1,IAZ
      A1=AZ(1,I)
      A2=AZ(2,I)
      A3=AZ(3,I)
      A4=AZ(4,I)
      A5=AZ(5,I)
      A6=AZ(6,I)
      CALL REZE(A1,A2,A3,A4,A5,A6,AR,VOL,1)
      AZ(1,I)=A1
      AZ(2,I)=A2
      AZ(3,I)=A3
      AZ(4,I)=A4
      AZ(5,I)=A5
5     AZ(6,I)=A6
10    CONTINUE
C     IAM=1
      CALL SORT7(IAZ,VVV,AZ,500,6)
      IDA=1
      VFF=A2*0.0001
      IF(IOR.EQ.3)VFF=VFF*50.
      IAZM=IAZ-1
      DO 60 ID=1,IAZM
      I=ID+1
      DO 50 J=1,6
      IF(ABS(AZ(J,ID)-AZ(J,I))-VFF)50,50,55
50    CONTINUE
      GO TO 60
55    DO 56 J=1,6
56    AZ(J,IDA)=AZ(J,ID)
      VVV(IDA)=VVV(ID)
      IDA=IDA+1
60    CONTINUE
      DO 63 J=1,6
63    AZ(J,IDA)=AZ(J,IAZ)
      VVV(IDA)=VVV(IAZ)
      CALL VERG(IDA,IOR)
      RETURN
      END
      FUNCTION ARCOS(X)
      ARCOS=ACOS(X)
      RETURN
      END
      BLOCK DATA
      COMMON/QUAD/IG
      DIMENSION IG(84)
      DATA IG/-1,0,1,1,1,5*4,7*9,9*16,11*25,13*36,15*49,17*64,81,81/
      END
      SUBROUTINE  GLG(A,M,N,IR,INV,LU,DELTA,IRO)
      DIMENSION A(6,7)  ,JF(50),IB(50),IL(50),IG(50)
      NR=N+IR
      DELTA =1.
      IRO = 0
      DO 3 I=1,M
      JF(I)= 0
      IB(I)= 0
      IL(I)= I
    3 IG(I)= I
      K = 1
      IQ1 = 0
    6 W = 0.
      IQ1 = IQ1 + 1
      DO 10 I=1,M
      IF(IB(I))  8,8,10
    8 IF(ABS(A(I,IQ1))-ABS(W))10,10,9
    9 W = A(I,IQ1)
      IPHI = I
   10 CONTINUE
      IF(W) 13,14,13
   14 IF(LU) 15,15,16
15    CONTINUE
      DELTA=0.
      GO TO 60
   16 IF(IQ1-N) 6,40,6
   13 DELTA = W*DELTA
      IRO = IRO+1
      JF(K)=IPHI
      IB(IPHI)=1
      A(IPHI,IQ1) = 1./W
      DO 21 I= 1,M
      IF(I-IPHI) 20,21,20
   20 A(I,IQ1)= -A(I,IQ1)/W
   21 CONTINUE
      IF(IQ1-1) 24,26,24
   24 IF(INV) 26,26,25
   25 J1= 1
      JMAX = IQ1-1
      GO TO  27
   26 J1= IQ1+1
      JMAX = NR
   27 DO 34 J= J1,JMAX
      IF(A(IPHI,J)) 28,34,28
   28 ALPHA = A(IPHI,J)
      A(IPHI,J) = ALPHA/W
      DO 32 I= 1,M
      IF(I-IPHI) 31,32,31
   31 A(I,J)= A(I,J)+ALPHA*A(I,IQ1)
   32 CONTINUE
   34 CONTINUE
      IF(JMAX-NR) 37,38,37
   37 IF(IQ1+1-NR) 26,26,38
   38 IF(M-K) 39,40,39
   39 K=K+1
      GO TO 6
   40 I=M-1
      DO 48 K=1,I
      IF(IG(K)-JF(K)) 42,48,42
   42 LAM    = JF(K)
      LAM    = IL(LAM)
      DO 43 J=1,NR
      W= A(K,J)
      A(K,J)= A(LAM,J)
   43 A(LAM,J) = W
      DELTA = -DELTA
      J1 = JF(K)
      JMAX=IG(K)
      IF(INV) 47,47,46
   46 DO 49 J=1,M
      W= A(J,J1)
      A(J,J1)=A(J,JMAX)
   49 A(J,JMAX)= W
   47 IL(J1)= K
      IL(JMAX)= LAM
      IG(LAM)=IG(K)
      IG(K) = JF(K)
   48 CONTINUE
60    CONTINUE
      RETURN
      END
      SUBROUTINE ITO(Q,NE,NAB,MEN,FEHLP,DX,R,MZ,IQX,IZE,VKL,ITA)
        DIMENSION Q(50),AL(6),AT(6),AS(6),R(500),AJ(5),IH(200),QP(200)
     1,DX(100),IQ(200),IQX(100,12),ALL(6),ATT(6),ASS(6)
     1,IND1(18,2),IND2(12),DR(200),LSL(10)
      COMMON/LSG/AZ(6,500),VVV(500)
C      EQUIVALENCE (AZ(1),IH(1)),(AZ(201),QP(1)),
C    1(AZ(501),IQ(1)),(AZ(701),DR(1))
      DATA AL/0.75,1.33333333,0.41666666,1.875,0.75,0.29166666/
      DATA AT/1.25,1.66666666,1.08333333,2.125,1.25,1.04166666/
      DATA AS/0.5,0.33333333,0.16666666,0.25,0.125,0.08333333/
      DATA ALL/1.3333333,2.4,0.75,0.53333333,1.3333333,0.41666666/
      DATA ATT/1.66666666,2.6,1.25,1.1333333,1.6666666,1.0833333/
      DATA ASS/0.33333333,0.2,0.125,0.066666666,0.083333333,0.041666666/
      DATA IND1/1,2,3,4,5,6,2,3,3,4,4,4,1,1,2,1,2,3,1,2,3,4,5,6,1,1,2,1,
     12,3,2,3,3,4,4,4/
      DATA IND2/3,5,4,5,6,6,1,1,2,3,2,4/
      DATA AJ/1.,0.25,0.1111111,0.0625,0.04/
      IF(IZE-4)4,5,5
4     CONTINUE
      LGR=MEN
      GO TO 7
5     DO 6 I=1,6
      J=I+6
      K=I+12
      IND1(J,1)=IND2(I)
      IND1(J,2)=IND2(J)
      IND1(K,1)=IND2(J)
      IND1(K,2)=IND2(I)
      AL(I)=ALL(I)
      AT(I)=ATT(I)
6     AS(I)=ASS(I)
      LGR=5
7     CONTINUE
      INA=0
      A=Q(1)
      B=Q(2)
      ETA=FEHLP
      DEMI2=VKL/B
      DEMI3=VKL/A
      DIF2=Q(1)*Q(3)-DEMI2
      DIF3=Q(2)*Q(3)-DEMI3
      MENK=MEN*(MEN-1)/2
C      MEX=MEN**2*NE
      IS=3
      MZ=0
      JADE=1
      WAB2=2.0*SQRT(A*B)
10    CONTINUE
C      AB=A*B
      ALU=A+B
      ALI=B-A
      R(1)=0.
C
C      MV=1
      J=1
      DO 20 I=IS,NE
      QI=Q(I)
      RR=ABS(QI-ALU)
      IF(RR-WAB2)14,14,16
14    J=J+1
      R(J)=RR
      DR(J)=QI*ETA
      QP(J)=QI
      IQ(J)=I
      IH(J)=1
16    DO 20 L=2,LGR
      RR=ABS(QI*AJ(L)-ALU)
      IF(RR-WAB2)18,18,20
18    J=J+1
      R(J)=RR
      DR(J)=QI*AJ(L)*ETA
      QP(J)=QI
      IQ(J)=I
      IH(J)=L
20    CONTINUE
      DO 31 L=1,MENK
      AL1=ALU*AT(L)
      AL2=ALI*AL(L)
      ALS=AL1+AL2
      ALT=AL1-AL2
      LL=6+L
      DO 30 I=IS,NE
      QAS=Q(I)*AS(L)
      RR=ABS(QAS-ALS)
      IF(RR-WAB2)24,24,25
24    J=J+1
      R(J)=RR
      QP(J)=Q(I)
      DR(J)=QAS*ETA
      IQ(J)=I
      IH(J)=6+LL
25    RR=ABS(QAS-ALT)
      IF(RR-WAB2)26,26,30
26    J=J+1
      R(J)=RR
      DR(J)=QAS*ETA
      QP(J)=Q(I)
      IQ(J)=I
      IH(J)=LL
30    CONTINUE
31    CONTINUE
      JH=J-1
      NB=1
      DO 32 L=2,JH
      IF(R(L).LT.B)NB=NB+1
32    CONTINUE
      DO 40 L=2,JH
      IF(R(L).LE.R(L+1))GO TO 40
      I=L+1
35    TT=R(I)
      IT=IH(I)
      QT=QP(I)
      IIQ=IQ(I)
      DRI=DR(I)
      II=I-1
      R(I)=R(II)
      IH(I)=IH(II)
      QP(I)=QP(II)
      IQ(I)=IQ(II)
      DR(I)=DR(II)
      R(II)=TT
      IH(II)=IT
      QP(II)=QT
      IQ(II)=IIQ
      DR(II)=DRI
      I=II
      IF(R(I)-R(I-1))35,40,40
40    CONTINUE
      BN=NB
      RMAX=R(J)
      IF(RMAX.LE.B)GO TO 43
      RO=BN/B
      IF((RMAX*0.9).LT.B)GO TO 44
      BNJ=J-NB
      RMB=RMAX-B
      ER1=BNJ-RMB*RO
      IF(ER1.LE.0)GO TO 44
      RK1=2.*ER1/RMB**2
      RK0=RO-RK1*B
      LR=1
      GO TO 45
43    RO=FLOAT(J)/RMAX
44    LR=0
45    CONTINUE
      IF(ITA.EQ.0)GO TO 102
      WRITE(6,203)A,B
      WRITE(6,204)
102   CONTINUE
      KM=2
      DO 60 L=2,JH
      IH1=IH(L)
      M1=IND1(IH1,1)
      N1=IND1(IH1,2)
      IF(ITA.EQ.0)GO TO 103
      WRITE(6,209)L,R(L),QP(L),IQ(L),DR(L),M1,N1
103   CONTINUE
      K=L+1
      KN=2
      IF(IQ(L).EQ.IQ(K))GO TO 60
      IF(KM-K)106,106,105
105   IF(KM.GT.J)GO TO 60
      K=KM
      I3=L+2
      GO TO 110
106   I3=K
110   KM=K
46    CONTINUE
      IF(R(L)-R(K)+DR(L)+DR(K))49,49,47
47    CONTINUE
      IF(K-L-1)126,126,115
115   DO 125 I1=I3,K
      I2=I1-1
      DO 120 I=L,I2
      IF(IQ(I)-IQ(I1))120,125,120
120   CONTINUE
      KN=KN+1
      LSL(KN)=I1
125   CONTINUE
126   K=K+1
      I3=K
      IF(K-J)46,46,50
49    IF(K-KM)60,60,50
50    KM=K
      KR=KM-L
      IL=L-1
      IF(IS.NE.3)GO TO 55
      DO 54  I1=3,NE
      DO 51 I=1,KR
      IF(I1-IQ(IL+I))51,54,51
51    CONTINUE
      FD=A*B-VKL/Q(I1)
      IF(FD)52,53,53
52    JADE=-1
      GO TO 60
53    RHST=2.*SQRT(FD)
      IF(R(L)-RHST)55,55,60
54    CONTINUE
55    MZ=MZ+1
      IQX(MZ,1)=IQ(L)
      IQX(MZ,2)=IQ(L+1)
      IF(KN-2)60,130,135
130   DBR=DR(L)+DR(L+1)
      GO TO 140
135   DO 138 I=3,KN
      IP=LSL(I)
138   IQX(MZ,I)=IQ(IP)
      DBR=R(IP)-R(L)
140   CONTINUE
      IF(LR)56,56,57
56    DX(MZ)=FLOAT(KN)/(RO*DBR+1.)
      GO TO 58
57    IF(R(L).LE.B)GO TO 56
      DX(MZ)=FLOAT(KN)/((RK1*R(L)+RK0)*DBR+1.)
58    CONTINUE
      IQX(MZ,KN+1)=0
      IF(ITA.EQ.0)GO TO 60
      WRITE(6,205)DX(MZ),KR,KN
60    CONTINUE
      IF(NAB-3)80,65,65
65    INA=INA+1
      IF(INA-2)66,68,80
66    B=Q(3)
      IF(JADE.GT.0)GO TO 67
      IF(MZ.GT.0)GO TO 80
      WRITE(6,202)
      CALL EXIT
67    CONTINUE
      IF(DIF2.LT.0.)GO TO 80
      WAB2=2.*SQRT(DIF2)
      IS=4
      GO TO 10
68    A=Q(2)
      IF(DIF3.LT.0.)GO TO 80
      WAB2=2.*SQRT(DIF3)
      GO TO 10
80    CONTINUE
202   FORMAT(1H0,10X,20HNO SOLUTION POSSIBLE /11X,22(1H*)///)
203   FORMAT(1H0,/15X,2HA=,F10.5,10X,2HB=,F10.5)
204   FORMAT('  L ',9X,'R(L)',11X,'QP(L)',5X,'IQ',10X,'DR(L)',9X,'M  N'
     1,7X,'DX',10X,'KR  KN')
205   FORMAT(1H+,66X,F13.4,I8,I4)
209   FORMAT(1X,I3,2F15.6,I6,F15.6,I10,I3)
      RETURN
      END
      SUBROUTINE MAUS(S,F,M,N,AK,AKM,VT1,AM)
      DIMENSION F(50,6),S(50),A(6,7  ),AK(6),AKM(6),B(50),VT(100)
      DO 3 I=1,M
3     B(I)=0
      DO 5 J=1,M
      DO 5 I=1,N
5     B(J)=B(J)+S(I)*F(I,J)
      DO 7 J=1,M
      DO 7 I=1,M
7     A(I,J)=0
      DO 10 K=2,M
      KMIN=K-1
      DO 10 J=1,KMIN
      DO 9 I=1,N
9     A(J,K)=A(J,K)+F(I,J)*F(I,K)
10    A(K,J)=A(J,K)
      DO 11 J=1,M
      DO 11 I=1,N
11    A(J,J)=A(J,J)+F(I,J)**2
      CALL GLG(A,M,M,0,1,LU,DELTA,IRO)
      IF(ABS(DELTA)-0.5)16,16,17
16    N=-1
      GO TO 36
17    CONTINUE
      DO 20 J=1,M
      IF(A(J,J))16,20,20
20    CONTINUE
      DO 24 J=1,6
24    AK(J)=0.
      DO 26 J=1,M
      AK(J)=0.
      DO 26 K=1,M
26    AK(J)=AK(J)+A(J,K)*B(K)
      VT1=0.
      VT2=0.
      DO 30 J=1,N
      VT(J)=0.
      DO 29 I=1,M
29    VT(J)=VT(J)+AK(I)*F(J,I)
      VT(J)=S(J)-VT(J)
      VT1=VT1+VT(J)
30    VT2=VT2+VT(J)**2
      ZN=N-M
      AM=SQRT(VT2/ZN)
      DO 34 J=1,M
34    AKM(J)=AM*SQRT(ABS(A(J,J)))
36    CONTINUE
      RETURN
      END
      SUBROUTINE MONO (V1Z,VD1Z,NZMAX,NQ,MOM,IUNAB,QN)
      INTEGER HDMA,HPA
      INTEGER HA,HB,HC,HD,H3M,H4M,HD1,H3MM
      COMMON FEL(50),Q(50),NNN,LUFM,FEHLP,ITER
      COMMON /LSG/AZ(6,500),VVV(500)
      COMMON /ZEIT/TILL
      COMMON /BEST/WMB
      DIMENSION P(17),PI(5),VG(10),VK(10)
      DATA P/0.,1.,4.,9.,16.,25.,36.,49.,64.,81.,100.,121.,144.,
     +   169.,196.,225.,256./
      DATA PI/1.,0.25,0.111111111,0.0625,0.04/
      DATA H3M,K3M,L3M,H4M,K4M,L4M/6*3/
      DATA  AU3/1./
      MOM=MOM+1
      WMB=0
      IRUN=0
      IZA=0
      IZB=0
      IZC=0
      WRITE(6,2000)
C     SUCHE NACH GEIGNETEN Q-WERTEN FUER DIE SYSTEMMATRIX
      FEHL=FEHLP*1.5
      IF(IUNAB.LE.0)GO TO 20
10    CONTINUE
      CALL UNMON(Q,FEHL,W,IRUN)
      CALL SORT1(NQ,Q,50,5)
      WRITE(6,2001)(Q(I),I=1,4),W
20    CONTINUE
      Q1=Q(1)
      Q2=Q(2)
      Q3=Q(3)
      Q4=Q(4)
      JAZ=0
C      N20=MIN0(NNN,20)
C      NZMI=1
      VMI=1./SQRT(Q1*Q2*Q4)
      CALL VGR(QN,V1Z,VD1Z,NZMAX,VMI,FEHLP,4,VK,VG,JV)
      IF(MOM)51,51,50
50    H3M=MOM
      K3M=MOM
      L3M=MOM
      H4M=MOM+1
      K4M=MOM
      L4M=MOM
51    CONTINUE
      HPA=3
C     BEREITSTELLUNG DER PARAMETER H3,K3,L3,H4,K4,L4
      M4=H4M
      M3=H3M
      KC1=2
      HD1=2
C             1      HC1=1
      N4=K4M
      N3=K3M
      LL=1
      JA=1
      JB=1
100   DO 1050 LA=1,L4M
      T4=P(LA)
      DO 1040 KA=1,N4
      S4=P(KA)
      IF(LL.EQ.2)JA=2-MOD(KA,2)
      DO 1030 HA=JA,M4,LL
      R4=P(HA)
      RS4=(HA-1)*(KA-1)
      H3MM=M3+1
      DO 1020 LB=1,L3M
      T3=P(LB)
      IF(LB.NE.1)H3MM=H3M
      TRZ2=SECOND(TTZZ)
      IF(TRZ2.GT.TILL)THEN
          WRITE(*,*)' TIMELIMIT'
          IF(JAZ.LE.0)GO TO 1500
          CALL AMT(JAZ,4)
          STOP
       ENDIF
C     BERECHNUNG FUER     K1=K2=0  MIT TAUSCH Q1 GEGEN Q2
      IF(RS4.LT.0.1)GO TO 320
      RS4I=1./RS4
      GD=R4*RS4I
      DO 315 KB=LL,N3,LL
      QQ1=Q1
      QQ2=Q2
      Q3IK=Q3*PI(KB)
      G5=(Q4-Q3IK*S4)*RS4I
      T3IK=T3*PI(KB)
      G7=(T4-T3IK*S4)*RS4I
      DO 310 JE=1,2
      DO 308 LC=1,3
      LC1=LC+1
      TC=LC*LC
      GA=TC*QQ1
      G8=QQ2*PI(LC)
      GX=G5-G8*G7
      DO 306 HC=1,HPA,LL
      G9=P(HC)*PI(LC)
      GY=GD-G9*G7
      DO 304 LD=1,LC1
      GE=P(HC)*P(LD)
      GB=GA-P(LD)*QQ2
      HDMA=HPA
      IF(LD.EQ.LC1)HDMA=HC-1
      DO 302 HD=1,HDMA,LL
      DET=P(HD)*TC-GE
       IF(ABS(DET).LT.0.1)GO TO 302
      A=GB/DET
      IF(A.LE.0.)GO TO 302
      C=G8-A*G9
      IF(C.LE.0.)GO TO 302
      B=Q3IK-C*T3IK
      IF(B.LE.0.)GO TO 302
      D=GX-A*GY
      IZA=IZA+1
      CALL ZELLCHK(A,B,C,D,IZB,IZC,JAZ,VG,VK,JV,LL,NQ,FEHL)
302   CONTINUE
304   CONTINUE
306   CONTINUE
308   CONTINUE
      QQ1=Q2
      QQ2=Q1
310   CONTINUE
315   CONTINUE
320   CONTINUE
C     BERECHNUNG FUER BELIEBIGES L1, MIT  K1=H2=0.
      DO 1010 KB=1,N3
      S3=P(KB)
      IF(LL.EQ.2)JB=2-MOD(KB,2)
      DO 1000 HB=JB,H3MM,LL
      IF(LB.GE.LA.AND.KB.GE.KA.AND.HB.GE.HA)GO TO 1010
      R3=P(HB)
      RS3=(HB-1)*(KB-1)
110   CONTINUE
      DEBD=RS4*S3-S4*RS3
      G34=T3*RS4-T4*RS3
      G24=-DEBD
      G14=-R3*RS4+R4*RS3
      G23=S3*T4-S4*T3
      G13=R3*T4-R4*T3
      G12=R3*S4-R4*S3
C     STARTWERTE MIT FESTEM  K2,L2,H1,L1     (NUR WERTE  0 ODER 1).
C                  K2=H1=1, L2=L1=0.
      IF(ABS(G34).LT.0.5)GO TO 400
      Y1=Q3-Q1*R3-Q2*S3
      Y2=Q4-Q1*R4-Q2*S4
      AU1=Q1
      AU2=Q2
      AU3=(RS4*Y1-RS3*Y2)/G34
      AU4=(-T4*Y1+T3*Y2)/G34
      JJ=1
      IF(ABS(G14).LT.0.5)GO TO 410
      GO TO 407
C                  K2=L1=0, L2=H1=1.
400   CONTINUE
      IF(ABS(G24).LT.0.5)GO TO 405
      Y1=Q3-Q1*R3-Q2*T3
      Y2=Q4-Q1*R4-Q2*T4
      AU1=Q1
      AU2=-(RS4*Y1-RS3*Y2)/G24
      AU3=Q2
      AU4=(S4*Y1-S3*Y2)/G24
      JJ=2
      GO TO 406
C                  K2=L1=1, L2=H1=0
405   JJ=3
406   IF(ABS(G14).LT.0.5)GO TO 900
407   Y1=Q3-Q2*S3-Q1*T3
      Y2=Q4-Q2*S4-Q1*T4
      AW1=(-RS4*Y1+RS3*Y2)/G14
      AW2=Q2
      AW3=Q1
      AW4=(R4*Y1-R3*Y2)/G14
C     LOESUNGEN MIT K2,L2  VARIABEL, H1,L1 KONSTANT
410   CONTINUE
      DO 500 LC=1,3
      T2=P(LC)
      T2E=T2-1
      T2G=T2*G24
      T2C=T2*AU3
      DO 500 KC=KC1,3
      S2=P(KC)
      S2E=S2-1
      S2U=S2E
      IF(JJ-2)415,425,420
C                  H1=1, L1=0
415   DE1=G34*S2+T2G
      IF(ABS(DE1).LT.0.5)GO TO 419
      YT=(S2U*AU2+T2C)/DE1
416   ZH=1
      ZL=0
      A1=AU1
      A2=AU2-YT*G34
      A3=AU3-YT*G24
      A4=AU4-YT*G23
      GO TO 430
419   IF(ABS(G14).LT.0.5)GO TO 500
C                  H1=0, L1=1
420   DE2=S2*G14
      YT=(S2E*Q2+T2*Q1)/DE2
      A1=AW1+YT*G24
      A2=AW2-YT*G14
      A3=AW3
      A4=AW4-YT*G12
      ZH=0.
      ZL=1.
      GO TO 430
C                  H1=1, L1=0, G34=0
425   IF(ABS(T2G).LT.0.5)GO TO 420
      YT=(S2*AU2+T2E*AU3)/T2G
      GO TO 416
430   CONTINUE
C     ALLGEMEINE LOESUNGEN
      WG1=S2*G34+T2*G24
      WG2=-T2*G14
      WG3=S2*G14
      WG4=S2*G13-T2*G12
C
C      JS=2
      DO 495 LD=1,3
      T1=P(LD)
      WL=T1*WG3
      YC=(T1-ZL)*A3
      DO 495 HD=HD1,3
      R1=P(HD)
      DET=R1*WG1+WL
      IF(ABS(DET).LT.0.5)GO TO 490
      YS=((R1-ZH)*A1+YC)/DET
      A=A1-YS*WG1
      IF(A.LE.0.)GO TO 490
      B=A2-YS*WG2
      IF(B.LT.0.)GO TO 490
      C=A3-YS*WG3
      IF(C.LT.0.)GO TO 490
      D=A4-YS*WG4
      CALL ZELLCHK(A,B,C,D,IZB,IZC,JAZ,VG,VK,JV,LL,NQ,FEHL)
490   CONTINUE
495   CONTINUE
500   CONTINUE
900   CONTINUE
      IF(RS3-0.1)1000,1000,999
999   IF(HA.EQ.1)GO TO 1000
      IF(KA.EQ.1)GO TO 1000
      RS3=-RS3
      GO TO 110
1000  CONTINUE
1010  CONTINUE
1020  CONTINUE
1030  CONTINUE
1040  CONTINUE
1050  CONTINUE
      IF(LL-2)1060,1061,1061
1060  LL=2
      KC1=3
      HD1=3
C      HC1=3
      M3=H3M+1
      M4=H4M+1
      N3=K3M+1
      N4=K4M+1
      HPA=5
      GO TO 100
1061  CONTINUE
      IF(JAZ.GT.0)CALL AMT(JAZ,4)
1500  CONTINUE
      IF(WMB.GT.10.)GO TO 1600
      IF(IUNAB.LE.0)GO TO 1600
      IF(IRUN.GE.1)GO TO 1600
      IRUN=IRUN+1
      WRITE(6,2002)
      GO TO 10
1600  CONTINUE
      RETURN
2000  FORMAT(//42X,27HSEARCH FOR MONOCLINIC CELLS/42X,27(1H*)//)
2001  FORMAT(12H0BASELINES  ,8X,3HQ1=,F8.5,5X,3HQ2=,F8.5,5X,3HQ3=,F8.5
     1,5X,3HQ4=,F8.5,42X,3HW= ,F4.1/)
2002  FORMAT(/94H NO SOLUTION WITH M20 GREATER THAN 10 DETECTED. A SECON
     1D TRIAL WITH NEW BASIC LINES IS STARTED)
      END
      SUBROUTINE ORDER(Q,FEHL,MQ)
      DIMENSION Q(50),F(3)
      DATA F/2.25,4.,9./
      NQ=MQ
      CALL SORT1(NQ,Q,50,1)
      X=1.+FEHL
      Y=1.-FEHL
      K2=16
      DO 20 J=1,6
      L=1
      QJL=Q(J)*F(1)
      K1=J+1
      DO 15 K=K1,K2
4     IF(QJL-Q(K)*Y)10,5,5
5     IF(QJL-Q(K)*X)6,6,15
6     QX=Q(K)
      NQ=MQ-1
      DO 7I=K,NQ
7     Q(I)=Q(I+1)
      Q(NQ+1)=QX
      IF(L.NE.1)MQ=MQ-1
10    IF(L.GE.3)GO TO 16
      L=L+1
      QJL=Q(J)*F(L)
       IF(QJL-Q(K2)*Y)4,4,16
15    CONTINUE
16    CONTINUE
20    CONTINUE
      RETURN
      END
      SUBROUTINE ZELLCHK(A,B,C,D,IZB,IZC,JAZ,VG,VK,JV,LL,NQ,FEHL)
C
C
C     UEBERPRUEFUNG DER GEFUNDENEN ELEMENTARZELLEN MIT VOLUMSBEDINGUNG
C
      DIMENSION VG(*),VK(*),P(17)
      COMMON FEL(50),Q(50),NNN,LUFM,FEHLP,ITER
      COMMON /LSG/AZ(6,500),VVV(500)
      COMMON /QUAD/IG(84)
      DATA P/0.,1.,4.,9.,16.,25.,36.,49.,64.,81.,100.,121.,144.,
     +   169.,196.,225.,256./
      IZB=IZB+1
      IF(LL-2)1085,1081,1085
1081  AA=A+B
      DD=ABS(A-B)
      A=AA+D
      B=AA-D
      D=DD*2
1085  FZ=A*B-0.25*D*D
      IF(FZ)1250,1250,1086
1086  VOL=FZ*C
      DO 1090 I=1,JV
      IF(VOL-VG(I))1089,1089,1090
1089  IF(VOL-VK(I))1250,1091,1091
1090  CONTINUE
      GO TO 1250
1091  CONTINUE
C     UEBERPRUEFUNG DER GEFUNDENEN ELEMENTARZELLEN MIT UEBRIGEN Q-WERTEN
      IZC=IZC+1
      CI=1./C
      D=ABS(D)
C
C     REDUCTION OF CELLS
C
1093  IF(A.LE.B)GO TO 1094
      AST=A
      A=B
      B=AST
1094  IF(D.LE.A)GO TO 1098
      B=B-D+A
      D=ABS(D-A-A)
      GO TO 1093
1098  CONTINUE
      LU=0
      GRK=FZ/A
      A2M=A+A
      DO 1200 I=5,NQ
      QQ=Q(I)
      IF(QQ.GT.(258.*A))GO TO 1200
      EPS=QQ*FEHL
      EPS2=EPS+EPS
      EPC=EPS2*CI
      EPC1=EPS*CI
1100  F=QQ+EPS
1103  FK=0.
1104  CONTINUE
      F1=F-B*FK*FK
      IF(F1)1120,1105,1105
1105  F2=D*FK
      F3=0.
      H=1
1107  CONTINUE
      F6=F1-A*P(H)-F3
      IF(F6)1111,1108,1108
1108  FA1=F6*CI+2.
      IF(FA1.GT.84.99)GO TO 1110
      FA2=FA1-EPC
      I1=FA1
      I2=FA2
      I2=MAX0(I2,1)
      IF(IG(I1)-IG(I2))1200,1109,1200
1109  H=H+1
      F3=F3+F2
      GO TO 1107
1110  FA1=FA1-2.
      F7=SQRT(FA1)
      I7=F7
      F8=I7
      IF((FA1-F7*F8).LT.EPC1)GO TO 1200
      IF(F1)1126,1109,1109
1111  IF(F2)1115,1115,1112
1112  F3=-F2
      H=2
      F2=-F2
      GO TO 1107
1115  FK=FK+1.
      GO TO 1104
1120  CONTINUE
      IF(F-GRK*FK*FK)1150,1150,1121
1121  F2=D*FK-A
      F6=F1
1123  F6=F6+F2
      IF(F6)1124,1125,1125
1124  IF(F2)1115,1126,1126
1125  CONTINUE
      FA1=F6*CI+2.
      FA2=FA1-EPC
      I1=FA1
      I2=FA2
      IF(IG(I1)-IG(I2))1200,1126,1200
1126  F2=F2-A2M
      GO TO 1123
1150  LU=LU+1
      IF(LU.GT.LUFM)GO TO 1250
1200  CONTINUE
      JAZ=JAZ+1
      AZ(1,JAZ)=A
      AZ(2,JAZ)=B
      AZ(3,JAZ)=C
      AZ(4,JAZ)=D
      AZ(5,JAZ)=0.
      AZ(6,JAZ)=0.
      VVV(JAZ)=VOL
      IF(JAZ-500)1250,1202,1202
1202  CALL AMT(JAZ,4)
      JAZ=0
1250  CONTINUE
      RETURN
      END
      SUBROUTINE ORIN(NNN,Q1,Q2,Q3,V1,V2,NZ,MAO1,MAO,ITA)
      IMPLICIT INTEGER(H)
      DIMENSION VV1(20),VV2(20),F(10),FI(10),G(10),FAK(10),DAK(10),
     1DCK(10)
      COMMON/LSG/AZ(6,500),VVV(500)/OR/IM,NQ
      FAK(1)=0.
      DATA F/0.,1.,4.,9.,16.,25.,36.,49.,64.,81./
C      IF(MAO)6,8,8
C6     MAO=0
C      GO TO 80
C8     CONTINUE
      IMM=IM+2
      IM1=IM-1
C      FG=F(IM)-0.01
C      DO 10 I=1,10
C10    FGK(I)=FG-F(I)
      DO 20 I=2,9
      FI(I)=1./F(I)
      G(I)=F(I)-1
20    FAK(I)=-G(I)*FI(I)
      DO 30 I=1,NZ
      J=NZ+1-I
      VV1(J)=1./(FLOAT(I)*V2)**2
30    VV2(J)=1./(FLOAT(I)*V1)**2
C     BERECHNUNG VON A,B,C  FUER L1=L2=0
      L1=1
      L2=1
C      NU1=3
C      NU2=NNN

      AMI=Q1*0.01
      DO 160 H2=1,IMM
      DO 160 K1=1,IM
      DEZ=F(H2)*F(K1)
      DO 150 K2=1,IMM
      DO 140 H1=K1,IMM
      IF(H1.GT.H2.AND.K1.GT.K2)GO TO 150
      DE=F(H1)*F(K2)-DEZ
      IF(ABS(DE).LT.0.5)GO TO 140
      DEI=1./DE
      A=(F(K2)*Q1-F(K1)*Q2)*DEI
      IF(A.LT.AMI)GO TO 140
      B=(F(H1)*Q2-F(H2)*Q1)*DEI
      IF(B.LT.AMI)GO TO 140
      FLCH=A*B
      DO 130 H3=1,IMM
      QA3=Q3-A*F(H3)
      IF(QA3.LT.0)GO TO 140
      DO 120 K3=1,IMM
      CZ=QA3-B*F(K3)
      IF(CZ.LT.0.)GO TO 130
      DO 110 L3=2,IM
      C=CZ*FI(L3)
      CALL ZELOCHK(A,B,C,MAO1,MAO,ITA,AMI,FLCH,VOL,VV1,VV2,NZ,NNN,INX)
107   IF(VOL.LT.VV2(1))GO TO 120
110   CONTINUE
120   CONTINUE
130   CONTINUE
140   CONTINUE
150   CONTINUE
160   CONTINUE
C      GO TO (235,280,350,107),ISU
C     ALLGEMEINE  MATRIXINVERSION
      DO 400 L3=1,IM1
      FL32=F(L3)*Q2
      DO 400 K3=L3,IM
      FK32=F(K3)*Q2
      KS=K3
      IF(KS.LE.1)KS=2
      DO 400 H3=KS,IMM
      FH32=F(H3)*Q2
      DO 400 L2=1,IM
      FL23=F(L2)*Q3
      FL=-FL32+FL23
      K2S=1
      IF(L3.EQ.K3)K2S=L2
      DO 400 K2=K2S,IM
      HT=IM
      HS=1
      IF(L2.GE.L3.AND.K2.GE.K3)HT=H3-1
      IF(HS.GT.HT)GO TO 400
      FK23= F(K2)*Q3
      FK=FK23-FK32
      E11=F(K2)*F(L3)-F(K3)*F(L2)
      DO 390 H2=HS,HT
      E21=-F(H2)*F(L3)+F(H3)*F(L2)
      E31=F(H2)*F(K3)-F(H3)*F(K2)
      FH23=F(H2)*Q3
      FH=FH23-FH32
      IF(ABS(E11)-0.5)200,202,202
200   IE1=0
      IF(ABS(E21).LT.0.5.AND.ABS(E31).LT.0.5)GO TO 390
      GO TO 203
202   IE1=1
      EH2=E21/E11
      EH3=E31/E11
      AS1=Q1
      BS1=EH2*Q1-FL/E11
      CS1=EH3*Q1+FK/E11
203   CONTINUE
      IF(ABS(E21)-0.5)205,205,207
205   IE2=0
      GO TO 208
207   EK1=E11/E21
      EK3=E31/E21
      AS2=EK1*Q1+FL/E21
      BS2=Q1
      CS2=EK3*Q1-FH/E21
      IE2=1
208   CONTINUE
      IF(ABS(E31)-0.5)210,210,212
210   IE3=0
      GO TO 213
212   EL1=E11/E31
      EL2=E21/E31
      AS3=EL1*Q1-FK/E31
      BS3=EL2*Q1+FH/E31
      CS3=Q1
      IE3=1
213   CONTINUE
C     L1=0  ODER  H2**2*K3**2=H3**2*K2**2
C         H2**2*L3**2=H3**2*L2**2
      IF(L2.EQ.1.AND.IE3.NE.0)GO TO 320
220   IF(IE2)222,222,260
222   CONTINUE
      IF(IE1.EQ.0)GO TO 320
      AL=AS1
      B=BS1
      CL=CS1
C      ISU=1
      R1K=B*EH3
      DO 225 J=2,IM
      DAK(J)=-F(J)*B
225   DCK(J)=-F(J)*R1K
      L1S=1
      IF(L2.EQ.1)L1S=2
      DO 250 L1=L1S,IM
      AK=AL
      CK=CL
      K1M=1
      IF(K2.EQ.1)GO TO 238
      K1=K1M
230   A=AK
      C=CK
      H1M=IM
      IF(L1.GE.L2.AND.K1.GE.K2)H1M=H2-1
      IF(H1M.LT.2)GO TO 240
      H1=2
232   FLCH=A*B
      CALL ZELOCHK(A,B,C,MAO1,MAO,ITA,AMI,FLCH,VOL,VV1,VV2,NZ,NNN,INX)
235   IF(H1.GE.H1M)GO TO 238
      H1=H1+1
      WK=AK*FAK(H1)
      A=AK+WK
      C=CK+WK*EH3
      GO TO 232
238   CONTINUE
      IF(K1.GE.IM)GO TO 240
      K1=K1+1
      AK=AL+DAK(K1)
      CK=CL+DCK(K1)
      GO TO 230
240   CONTINUE
      IF(IE3.NE.0)GO TO 320
      AL=AS1-F(L1+1)*CS1
250   CONTINUE
      GO TO 400
C     (H2**2*L3**2).NE.(H3**2*L2**2)
260   CONTINUE
      DO 262 I=2,IM
      DAK(I)=FAK(I)*EK1
262   DCK(I)=FAK(I)*EK3
      AL=AS2
      BL=BS2
      CL=CS2
C      ISU=2
      L1S=1
      IF(L2.EQ.1)L1S=2
      DO 300 L1=L1S,IM
      AK=AL
      BK=BL
      CK=CL
      K1=2
270   CONTINUE
      A=AK
      B=BK
      C=CK
      H1=1
      IF(H2.EQ.1)GO TO 280
      H1MA=IM
      IF(L1-L2)275,272,272
272   IF(K1-K2)275,273,273
273   H1MA=H2-1
      IF(H1MA.LT.H1)GO TO 290
275   FLCH=A*B
      CALL ZELOCHK(A,B,C,MAO1,MAO,ITA,AMI,FLCH,VOL,VV1,VV2,NZ,NNN,INX)
280   IF(H1.GE.H1MA)GO TO 282
      H1=H1+1
      F1H=F(K1)*FI(H1)+EK1
      IF(ABS(F1H).LT.0.00001)GO TO 280
      WK=-AK/F1H
      A=AK+WK*EK1
      B=BK+WK
      C=CK+WK*EK3
      GO TO 275
282   CONTINUE
      IF(K1.GE.IM)GO TO 290
      K1=K1+1
      AK=AL+BL*DAK(K1)
      BK=BL+BL*FAK(K1)
      CK=CL+BL*DCK(K1)
      GO TO 270
290   IF(IE3.NE.0)GO TO 320
      D2C=-F(L1+1)*CS2
      AL=AS2+D2C*EK1
      BL=BS2+D2C
300   CONTINUE
      GO TO 390
C           L1.NE.0.AND.H2**2*K3**2.NE.H3**2*K2**2
320   CONTINUE
      H1S=1
      IF(H2.EQ.1)H1S=2
C      ISU=3
      DO  380 L1=2,IM
      WL=FAK(L1)*CS3
      AL=AS3+WL*EL1
      CL=CS3+WL
      BL=BS3+WL*EL2
      AK=AL
      BK=BL
      CK=CL
      K1=1
      DEL=E31*F(L1)
      DELK=DEL
      NSI=1
340   CONTINUE
      H1=H1S
      A=AK
      B=BK
      C=CK
      H1MA=IM
      IF(L1-L2)344,342,342
342   IF(K1-K2)344,343,343
343   H1MA=H2-1
      IF(H1MA.LT.H1)GO TO 370
344   IF(H1S-2)345,354,354
345   FLCH=A*B
      CALL ZELOCHK(A,B,C,MAO1,MAO,ITA,AMI,FLCH,VOL,VV1,VV2,NZ,NNN,INX)
350   CONTINUE
      IF(H1.GE.H1MA)GO TO 360
      H1=H1+1
354   IF(NSI)358,358,355
355   DELTA=DELK+F(H1)*E11
      IF(ABS(DELTA).LT.0.5)GO TO 350
      WH=-F(H1)/DELTA*AK
      A=AK+WH*E11
      B=BK+WH*E21
      C=CK+WH*E31
      GO TO 345
358   CONTINUE
      WH=FAK(H1)*AK
      A=AK+WH
      B=BK+WH*EH2
      C=CK+WH*EH3
      GO TO 345
360   CONTINUE
      IF(K1.GE.IM)GO TO 370
      K1=K1+1
      DELK=DEL+E21*F(K1)
      IF(ABS(DELK)-0.5)366,366,364
364   NSI=1
      WK=-F(K1)*BL/DELK
      AK=AL+WK*E11
      BK=BL+WK*E21
      CK=CL+WK*E31
      GO TO 340
366   IF(IE1.EQ.0)GO TO 360
      NSI=-1
      WK=-(AL+F(K1)*BL)
      AK=AL+WK
      BK=BL+WK*EH2
      CK=CL+WK*EH3
      GO TO 340
370   CONTINUE
380   CONTINUE
390   CONTINUE
400   CONTINUE
      RETURN
      END
      SUBROUTINE ZELOCHK(A,B,C,MAO1,MAO,ITA,AMI,FLCH,VOL,VV1,VV2,NZ
     1 ,NNN,INX)
C
C     CHECK IF CELLS ARE WITHIN POSSIBLE VOLUME RANGE
C     CALLS QZO FOR INDEXING ORTHORHOMBIC LATTICES AND CHECKS IF
C     CELL IS ORTHORHOMBIC
C     STORES RELIABLE CELLS
C
      DIMENSION VV1(*),VV2(*)
      COMMON/LSG/AZ(6,500),VVV(500)
      IF(A.LT.AMI.OR.B.LT.AMI)GO TO 105
      VOL=FLCH*C
      DO 100 I=1,NZ
      IF(VOL.LT.VV2(I))GO TO 105
      IF(VOL.GT.VV1(I))GO TO 100
      CALL QZO(A,B,C,6,3,6,-1,INX)
      IF(INX.LE.0)GO TO 100
      CALL QZO(A,B,C,NNN,3,NNN,-1,INX)
      IF(INX.LE.0)GO TO 100
      MAO=MAO+1
      VVV(MAO)=VOL
      AZ(1,MAO)=A
      AZ(2,MAO)=B
      AZ(3,MAO)=C
      IF(MAO.EQ.500)THEN
            IF(ITA.EQ.1)CALL ORWRITE(MAO1,MAO)
            CALL AMT(MAO,3)
            MAO=0
            MAO1=1
         ENDIF
      GO TO 105
100   CONTINUE
105   CONTINUE
      RETURN
      END
      SUBROUTINE FILEXT(FNAM,EXT)
C
C     Der Filename FNAM wird mit der Extension EXT ausgegeben
C     FNAM ist Eingabe und Ausgabeparameter
C
C     EINGABEPARAMETER
C         FNAM= BELIEBIGER FILENAME ,MIT ODER OHNE EXTENSION
C         EXT= CHARACTER*3 VARIABLE BESTEHEND AUS 3 CHARACTERS
C              z.B.:  NPF
C     AUSGABEPARAMETER
C         FNAM=   CHARACTER VARIABLE MIT DER EXTENSION EXT
C              z.B.:  IFILE.NPF
C
      CHARACTER FNAM*40,FNAM0*40,FNAM1*40,CH,CC,EXT*3,EXT1*3,EE
      DIMENSION CH(36),CC(40),EE(10)
      EQUIVALENCE (FNAM0,CH(1)),(FNAM1,CC(1)),(EXT1,EE(2))
      FNAM0=FNAM
      FNAM1=' '
      EE(1)='.'
      EXT1=EXT
      K=0
      DO 10 L=1,36
      IF(CH(L).EQ.' ')GO TO 10
      IF(CH(L).EQ.'.')GO TO 12
      K=K+1
      CC(K)=CH(L)
10    CONTINUE
12    CONTINUE
      IF(K.GT.0)GO TO 15
      WRITE(*,'('' FILENAME= ?'')')
15    CONTINUE
      DO 20 L=1,4
      K=K+1
      CC(K)=EE(L)
20    CONTINUE
      WRITE(*,*)' OUTPUTFILE=',FNAM1
      FNAM=FNAM1
      RETURN
      END
      SUBROUTINE FSELECT(IUR,IUW)
C
C     AUSWAHL DER FILES FUER DIE DATENEINGABE
C       PARAMETER WERDEN ENTWEDER VON DER COMMAND-LINE
C       ODER INTERAKTIV AUF ABFRAGE VOM TERMINAL EINGEGEBEN
C
C     IUR,IUW : AUSGABEPARAMETER
C     IUR....EINHEIT VON DER GELESEN WIRD
C             *...LESEN VOM TERMINAL
C             1...LESEN VOM FILE
C     IUW....AUSGABEEINHEIT
C     INPNAME = NAME DES INPUTFILES
C     IDEV    = DEVICE-NUMMER FUER PLOT88 STAPELJOBS
C       INPNAME UND IDEV sind in der Commandline durch Beistrich
C       getrennt:
C          TMO INPNAME,IDEV
C       Ist die Commandline ohne INPNAME und IDEV :
C          TMO
C       dann wird INPNAME interaktiv abgefragt und IDEV kann nicht
C       eingegeben werden.
C
      CHARACTER INPNAME*40,OUTNAME*40,FNAM*40,EXT*3,CLFORM*20,COMLINE*42
      COMMON /FNAME/INPNAME,IDEV
      DATA FNAM,EXT,COMLINE/'CON:','OUT',' '/
      IUR=5
      IUW=6
      IDEV=0
C       reading the comandline with LAHEY-compiler on IBM-PC or compatible
C       remove the following call to GETCL for other computers
      CALL GETCL(COMLINE)
C
      IND=INDEX(COMLINE,',')-1
      IF(IND.LT.0)THEN
             INPNAME=COMLINE
          ELSE
             WRITE(CLFORM,*)'(A',IND,',1X,I2)'
             READ(COMLINE,CLFORM)INPNAME,IDEV
          ENDIF
      IF(INPNAME.NE.' ')GO TO 8
5     WRITE(*,*)' "CON:"......DATENEINGABE VOM TERMINAL'
      WRITE(*,*)'FILENAME.....DATENEINGABE VON FILE FILENAME...'
      READ(*,1000)INPNAME
8     OPEN (UNIT=IUR,FILE=INPNAME,ERR=10,IOSTAT=IOS,STATUS='OLD')
      GO TO 14
10    CONTINUE
      IF(IOS.EQ.16455)THEN
           WRITE(*,*)' FILE DOES NOT EXIST'
           CALL SYSTEM('DIR/W')
           GO TO 5
         ELSE
           WRITE(*,*)' ERROR OPENENING INPUTFILE:    IOSTAT=',IOS
           STOP
         ENDIF
14    CONTINUE
      OUTNAME=INPNAME
      IF(OUTNAME.EQ.FNAM)GO TO 22
      CALL FILEXT(OUTNAME,EXT)
      OPEN(UNIT=IUW,FILE=OUTNAME)
22    CONTINUE
1000  FORMAT(A40)
      RETURN
       END
      SUBROUTINE ORTHOR(V1Z,VD1Z,NZMAX,ITA)
      DIMENSION MC(10),AMC(10)
      COMMON FEL(50),Q(50),MMM,LUFM,FEHLP,ITER/LSG/AZ(6,500),VVV(500)
     1/OR/IM,NNN
      DO 2 I=1,NNN
2     VVV(I)=1./VVV(I)
      WRITE(6,513)
      CALL SORT1(NNN,VVV,500,1)
      I4=2
      I3=11
      IF(NNN.LT.11)GO TO 8
      A=VVV(1)*0.5
3     X=(1.+0.5*FEHLP)/A
      Y=(1.-0.5*FEHLP)/A
      DO 6 I=I4,10
      I1=VVV(I)*X
      I2=VVV(I)*Y
      IF(I1-I2)4,6,4
4     S=VVV(I)
      VVV(I)=VVV(I3)
      VVV(I3)=S
      IF(I3.GE.NNN)GO TO 8
      I3=I3+1
6     CONTINUE
      CALL SORT1(10,VVV,500,1)
      IF(I4.EQ.3)GO TO 8
      A=VVV(2)*0.5
      I4=3
      GO TO 3
8     CONTINUE
      DO 9 I=1,NNN
9     Q(I)=VVV(I)*VVV(I)
      DO 10 I=1,NNN
10    FEL(I)=Q(I)*FEHLP
      A=Q(1)
      B=Q(2)
      CALL UNOR(3,8,MC,MCH)
      DO 12 I=1,MCH
      J=MC(I)
12    AMC(I)=Q(J)
      Q(1)=0.1E-10
      Q(2)=0.2E-10
      CALL SORT1(NNN,Q,50,1)
      Q(1)=A
      Q(2)=B
      DO 13 I=1,NNN
13    FEL(I)=Q(I)*FEHLP
C      AS=SQRT(A)
C      BS=SQRT(B)
      NRE=NNN
      IF(NRE.GT.20)NRE=20
      DRE=SQRT(Q(NRE))
      RNE=NRE
      VMA=8.*RNE/(0.524*DRE*Q(NRE))
      MAO=0
      DO 14 L=1,500
      AZ(4,L)=0.
      AZ(5,L)=0.
      AZ(6,L)=0.
14    CONTINUE
      DO 30 JJ=1,MCH
      MAO1=MAO+1
C
      C=AMC(JJ)
      WRITE(6,508)A,B,C
      IF(V1Z.GT.0)GO TO 15
      V1=VMA*0.75
      V2=1./SQRT(A*B*C)
      WRITE(6,506)V1,V2
      NZ=1
      GO TO 28
15    VR=VD1Z+1.5*FEHLP*V1Z
      V1=V1Z+VR
      V2=V1Z-VR
      NZ=VMA/V2
      IF(NZ.GT.NZMAX)NZ=NZMAX
28    CONTINUE
C      CALL ORIN(NNN,A,B,C,V1,V2,NZ,MAO)
      CALL ORIN(NNN,A,B,C,V1,V2,NZ,MAO1,MAO,ITA)
      IF(MAO1.GT.MAO)GO TO 30
      IF(ITA.EQ.1)CALL ORWRITE(MAO1,MAO)
C      IF(MAO.LT.500)GO TO 30
C      CALL AMT(MAO,3)
C      MAO=-1
C      MAO1=1
C      GO TO 28
30    CONTINUE
      IF(MAO.LE.0)RETURN
      CALL AMT(MAO,3)
509   FORMAT(1X,20A4)
506   FORMAT(1X,3HV1=,F10.4,10X,3HV2=,F10.4)
508   FORMAT(1H ,9HBASELINES,5X,3HQ1=,F8.5,5X,3HQ2=,F8.5,5X,3HQ3=,F8.5)
513   FORMAT(//42X,29HSEARCH FOR ORTHORHOMBIC CELLS/42X,29(1H*)////)
      RETURN
      END
      SUBROUTINE ORWRITE(MAO1,MAO)
C
C     WRITES ORTHORHOMBIC CELLS
C
      COMMON /LSG/AZ(6,500),VVV(500)
          DO 29 L=MAO1,MAO
          A1=1./SQRT(AZ(1,L))
          A2=1./SQRT(AZ(2,L))
          A3=1./SQRT(AZ(3,L))
          VOLUM=1./SQRT(VVV(L))
          WRITE(6,512)A1,A2,A3,VOLUM
29        CONTINUE
512   FORMAT(1X,3E15.6,10X,E15.6)
      RETURN
      END
      SUBROUTINE QERZ(A1,A2,A3,A4,A5,A6,Q,IQZM,MONO,QI,NQ,P,IRM,ISP,INS
     1,IW,Q20,IV)
      COMMON FEL(50),QAN(50),NNN,LUFM,FEHLP,ITER
     1/VQ/PF(50),LH(50),LK(50),LL(50),PF2(50)
     1,LH2(50),LK2(50),LL2(50),PFA(50)/VS/QP(400),IH(400),IK(400)
     2,IL(400)
      DIMENSION QI(50),P(50)
      INTEGER HD,HE,HD0
      VLM=A4*A5*A6-A1*A5**2-A2*A6**2
      IW=0
      IV=0
      WI=4.*A1*A2-A4**2
      IF(WI)99,99,100
99    IRM=0
      GO TO 500
100   CONTINUE
      AB4=4.*A1*A2
      MONO=6
       IDMO=1
      WIM=8.5E-06
      TA4=A4**2/AB4-WIM
      BC4=4.*A2*A3
      TA5=A5**2/BC4-WIM
      IF(TA4)406,440,440
406   IF(TA5)410,420,420
410   IF(A6**2/(4.*A1*A3)-WIM)411,411,415
411   A4=0.
      IDMO=-3
      MONO=3
      A4=0.
      A5=0.
      A6=0.
      VLM=0.
      GO TO 460
415   AW=A1
      A1=A3
      A3=A2
      A2=AW
      A4=A6
      GO TO 450
420   TA6=A6**2/(4.*A3*A1)-WIM
      IF(TA6)425,460,460
425   AW=A1
      A1=A2
      A2=A3
      A3=AW
      A4=A5
      GO TO 450
440   TA6=A6**2/(4.*A3*A1)-WIM
      IF(TA6.GE.0..OR.TA5.GE.0.)GO TO 460
450   IDMO=-1
      MONO=4
      VLM=0.
      A5=0.
      A6=0.
      AB4=4.*A1*A2
      IF((A4**2/AB4-WIM).GT.0.)GO TO 460
      A4=0.
      IDMO=-3
      MONO=3
460   CONTINUE
      DO 110 I=1,NQ
      PF(I)=10000.
      PF2(I)=PFA(I)
110   CONTINUE
      JK=1
      TH=-2.*A1
      TK=-2.*A2
      THK=-A4
      THKS=THK
      ZMAX=Q/(A3+VLM/WI)
      LMAX=SQRT(ZMAX)
      J=0
      ID=-1
      L=-1
115   L=L+1
      IN=INS
      VVL=L
      D0=Q-A3*VVL**2
      IF(D0)120,140,140
120   VDL=VVL/WI
      SHD0=(A4*A5-2.*A2*A6)*VDL
      SKD0=(A4*A6-2.*A1*A5)*VDL
      HD0=ABS(SHD0)+0.5
      KD0=ABS(SKD0)+0.5
      IF(SKD0.LT.0.)KD0=-KD0
      IF(SHD0.LT.0.)HD0=-HD0
      RHD=HD0
      RKD=KD0
      D0=D0-(A1*RHD+A4*RKD+A6*VVL)*RHD-(A2*RKD+A5*VVL)*RKD
      IF(D0)401,130,130
130   TD0H=-(2.*RHD+1.)*A1-A4*RKD-A6*VVL
      TD0K=-(2.*RKD+1.)*A2-A4*RHD-A5*VVL
      GO TO 150
140   TD0H=-A1-A6*VVL
      TD0K=-A2-A5*VVL
      HD0=0
      KD0=0
150   CONTINUE
      TDH=TD0H
      TDK=TD0K
      D=D0
      E=D0
      HD=HD0
      HE=HD
      KE=KD0
      KD=KD0
      TEH=TDH
      IF(L.GT.0.AND.IDMO.GT.0)GO TO 185
154   IF(E)170,160,160
160   J=J+1
      IF(ISP)162,162,161
161   KU=1
      GO TO 300
162   IF(J-IQZM)163,163,165
163   QP(J)=Q-E
      IH(J)=HE
      IK(J)=KE
      IL(J)=L
165   TEH=TEH-TH
      E=E-TEH
      HE=HE-1
      GO TO 154
170   D=D+TDK
      KD=KD+JK
      TDK=TDK+TK
      TDH=TDH+THK
      IF(D)190,180,180
180   E=D
      TEH=TDH
      KE=KD
      HE=HD
185   J=J+1
      IF(ISP)183,183,182
182   KU=2
      GO TO 300
183   IF(J-IQZM)184,184,186
184   QP(J)=Q-E
      IH(J)=HE
      IK(J)=KE
      IL(J)=L
186   E=E+TEH
      TEH=TEH+TH
      HE=HE+1
187   IF(E)188,185,185
188   IF(IDMO.EQ.-3)GO TO 170
      TEH=TDH-TH
      E=D-TEH
      HE=HD-1
      GO TO 154
190   E=D+TDH
      KE=KD
      HE=HD+1
      TEH=TDH+TH
      IF(E-D)210,210,200
200   IF(E)204,185,185
204   IF(TEH)210,206,206
206   E=E+TEH
      TEH=TEH+TH
      HE=HE+1
      GO TO 200
210   TEH=TDH-TH
      E=D-TEH
      HE=HD-1
      IF(E-D)230,230,220
220   IF(E)224,160,160
224   IF(TEH)228,230,230
228   TEH=TEH-TH
      E=E-TEH
      HE=HE-1
      GO TO 220
230   CONTINUE
      IF(ID)240,250,250
240   ID=IDMO
      JK=1
      THK=THKS
      GO TO 400
250   ID=-1
      JK=-1
      TDH=TD0H
      TDK=-TD0K+TK
      THK=-THK
      D=D0
      E=D0
      HD=HD0
      HE=HD
      KE=KD0
      KD=KD0
      TEH=TDH
      GO TO 170
300   QSP=Q-E
      FF=QI(IN)-QSP
      IF(FF)310,310,330
310   KEN=-1
314   IF(ABS(FF)-FEL(IN))350,350,315
315   IF(FF)316,316,380
316   IF(IN-NQ)317,380,380
317   IN=IN+1
      FF=QI(IN)-QSP
      GO TO 314
330   KEN=1
332   IF(ABS(FF)-FEL(IN))350,350,333
333   IF(FF)380,335,335
335   IF(IN-INS)380,380,336
336   IN=IN-1
      FF=QI(IN)-QSP
      GO TO 332
350   IF(ISP)390,390,355
355   EA=ABS(FF)
      IF(EA-PF(IN))356,365,365
356   LH2(IN)=LH(IN)
      LK2(IN)=LK(IN)
      LL2(IN)=LL(IN)
      LH(IN)=HE
      LK(IN)=KE
      LL(IN)=L
      IF(ABS(PF2(IN))-9900.)360,360,361
360   PF2(IN)=-PF(IN)
      GO TO 364
361   IF(PF2(IN)+99000.)364,363,363
363   PF2(IN)=PF(IN)
364   PF(IN)=EA
      GO TO 370
365   IF(ABS(PF2(IN))-9900.)366,366,367
366   PF2(IN)=-EA
      GO TO 370
367   IF(PF2(IN)+99000.)370,368,368
368   PF2(IN)=EA
      LH2(IN)=HE
      LK2(IN)=KE
      LL2(IN)=L
370   CONTINUE
      IF(KEN)316,316,335
380   IF(ISP-1)382,390,382
382   IF(QSP.LT.Q20)IV=IV+1
      IF(J-IQZM)384,384,390
384   IW=IW+1
      QP(IW)=QSP
      IH(IW)=HE
      IK(IW)=KE
      IL(IW)=L
390   GO TO (165,186),KU
400   IF(L.LT.LMAX)GO TO 115
401   CONTINUE
      IRM=0
      DO 478 IX=INS,NQ
      IF(PF(IX)-9000.)475,475,478
475   IRM=IRM+1
      P(IRM)=QI(IX)
      PF(IRM)=PF(IX)
      PF2(IRM)=PF2(IX)
      IF(PF2(IRM).GT.9000.)PF2(IRM)=-PF2(IRM)
      LH(IRM)=LH(IX)
      LK(IRM)=LK(IX)
      LL(IRM)=LL(IX)
      LH2(IRM)=LH2(IX)
      LK2(IRM)=LK2(IX)
      LL2(IRM)=LL2(IX)
478   CONTINUE
500   CONTINUE
      RETURN
      END
      SUBROUTINE QZO(A,B,C,NNN,NU1,NU2,IST,INX)
      INTEGER H
      DIMENSION HH(10),QQ(50),IQS(9),FEL(50)
      COMMON FFEL(50),Q(50),MMM,LUFM,FEHLP,ITER/VS/QP(400),IH(400)
     1,IK(400),IL(400)/QZ/IQ(9),IQN(9)
      DATA HH/0.,1.,4.,9.,16.,25.,36.,49.,64.,81./
      PMX=0.
      PA=0.
      INY=0
C      QMI=Q(NU1)
      QMA=Q(NU2)
      NUG=NU2
      NUK=NU1
      IF(PMX.GT.QMA)QMA=PMX
      IF(PA.GT.QMA)QMA=PA
      NA=0
      NMX=-1
      ID=IABS(IST)+1
      DO 10 I=1,NNN
      FEL(I)=FFEL(I)
10    QQ(I)=Q(I)
      IN=NU1
      QG=QMA*(1.+FEHLP)
      LGR=10
      IF(IST.EQ.0)LGR=1
      DO 120 L=1,LGR
      PL=C*HH(L)
      IF(PL.GT.QG)GO TO 122
      DO 110 K=1,10
      PK=PL+B*HH(K)
      IF(PK.GT.QG)GO TO 112
      DO 100 H=1,10
      P=PK+A*HH(H)
      IF(P.GT.QG)GO TO 102
      IF(ID-1)35,35,30
30    IF(P.LE.PMX)NMX=NMX+1
      IF(IST.LE.0)GO TO 35
      IF(P.GT.PA)GO TO 35
      NA=NA+1
      QP(NA)=P
      IH(NA)=H
      IK(NA)=K
      IL(NA)=L
35    CONTINUE
      FF=QQ(IN)-P
      IF(FF)40,40,50
40    KEN=-1
42    CONTINUE
      IF(ABS(FF)-FEL(IN))60,60,43
43    IF(FF)45,45,99
45    IF(IN-NUG)46,99,99
46    IN=IN+1
      FF=QQ(IN)-P
      GO TO 42
50    KEN=1
52    CONTINUE
      IF(ABS(FF)-FEL(IN))60,60,53
53    IF(FF)99,55,55
55    IF(IN-NUK)99,99,56
56    IN=IN-1
      FF=QQ(IN)-P
      GO TO 52
60    GO TO (75,61),ID
61    CONTINUE
      IF(NUG-NUK-LUFM)73,73,62
62    IF(KEN)63,63,68
63    IF(IN-NUK)66,66,64
64    IM=IN-NUK
      DO 65 J=1,IM
      I=IN-J
      FEL(I+1)=FEL(I)
65    QQ(I+1)=QQ(I)
66    NUK=NUK+1
      GO TO 43
68    IF(IN-NUG)69,72,72
69    IM=NUG-1
      DO 70 I=IN,IM
      FEL(I)=FEL(I+1)
70    QQ(I)=QQ(I+1)
72    NUG=NUG-1
      GO TO 53
73    INX=1
      GO TO 200
75    CONTINUE
      DO 76 I=1,INY
      IF(IN.EQ.IQS(I))GO TO 78
76    CONTINUE
      IQN(IN)=IQN(IN)+1
      INY=INY+1
      IQS(INY)=IN
78    IF(KEN)43,43,53
99    CONTINUE
100   CONTINUE
102   CONTINUE
110   CONTINUE
112   CONTINUE
120   CONTINUE
122   CONTINUE
      IF(IST)140,150,140
140   INX=-1
      GO TO 200
150   IF(INY.LE.INX)GO TO 200
      DO 152 I=1,INY
152   IQ(I)=IQS(I)
      INX=INY
200   CONTINUE
      IF(INY-NU2+NU1-1)300,250,250
250   WRITE(6,503)A,B
300   CONTINUE
503   FORMAT(1X,3HA*=,E16.6,10X,3HB*=,E16.6)
      RETURN
      END
      SUBROUTINE REZE(A1,A2,A3,A4,A5,A6,AR,VOL,IREAL)
      DIMENSION AR(9)
      VOL=A1*A2*A3+(A4*A5*A6-A1*A5**2-A2*A6**2-A3*A4**2)/4.
      IF(VOL.LE.0.)GO TO 100
      IF(IREAL)2,4,4
2     CONTINUE
      VOL=1./VOL
      B1=(A2*A3-(A5/2.)**2)*VOL
      B2=(A1*A3-(A6/2.)**2)*VOL
      B3=(A2*A1-(A4/2.)**2)*VOL
      B4=(A5*A6/2.-A3*A4)*VOL
      B5=(A6*A4/2.-A1*A5)*VOL
      B6=(A4*A5/2.-A2*A6)*VOL
      AR(1)=SQRT(B1)
      AR(2)=SQRT(B2)
      AR(3)=SQRT(B3)
      AR(4)=B5/AR(2)/AR(3)/2.
      AR(5)=B6/AR(3)/AR(1)/2.
      AR(6)=B4/AR(1)/AR(2)/2.
      IF(IREAL.EQ.(-2))GO TO 90
      A1=B1
      A2=B2
      A3=B3
      A4=B4
      A5=B5
      A6=B6
4     CONTINUE
5     CONTINUE
      IF(A1-A2)15,15,10
10    ASP=A1
      A1=A2
      A2=ASP
      ESP=A5
      A5=A6
      A6=ESP
15    CONTINUE
      IF(A2-A3)25,25,20
20    BSP=A2
      A2=A3
      A3=BSP
      DSP=A4
      A4=A6
      A6=DSP
      GO TO 5
25    CONTINUE
      IND=1
      IF(A4.LT.0.)IND=-IND
      IF(A5.LT.0.)IND=-IND
      IF(A6.LT.0.)IND=-IND
      A44=ABS(A4)
      A55=ABS(A5)
      A66=ABS(A6)
      IF(IND)30,35,35
30    A4=-A44
      A5=-A55
      A6=-A66
      GO TO 50
35    A4=A44
      A5=A55
      A6=A66
50    CONTINUE
      VIND=IND
      IF(A44-A1)55,55,52
52    A2=A2-A44+A1
      A4=A4-2.*A1*VIND
      A5=A5-A66
      GO TO 5
55    IF(A66-A1)60,60,56
56    A3=A3-A66+A1
      A5=A5-A44
      A6=A6-2.*A1*VIND
      GO TO 5
60    IF(A55-A2)65,65,61
61    A3=A3-A55+A2
      A5=A5-2.*A2*VIND
      A6=A6-A44
      GO TO 5
65    CONTINUE
      IF(IND)67,67,80
67    ABA=A1+A2+A4+A5+A6
      IF(ABA)69,69,80
69    A3=A3+ABA
      A5=A5+A4+2*A2
      A6=A6+A4+2*A1
      GO TO 5
80    CONTINUE
      IF(IREAL)85,82,82
82    CONTINUE
      AX1=(A2*A3-(A5/2.)**2)
      AX2=(A1*A3-(A6/2.)**2)
      AX3=(A2*A1-(A4/2.)**2)
      AR(1)=SQRT(AX1/VOL)
      AR(2)=SQRT(AX2/VOL)
      AR(3)=SQRT(AX3/VOL)
      AR(4)=(A6*A4/4.-A1*A5/2.)/SQRT(AX2*AX3)
      AR(5)=(A4*A5/4.-A2*A6/2.)/SQRT(AX3*AX1)
      AR(6)=(A5*A6/4.-A3*A4/2.)/SQRT(AX1*AX2)
      GO TO 90
85    CONTINUE
 90   CONTINUE
      GPI=180./3.141592654
      AR(7)=ARCOS(AR(4))*GPI
      AR(8)=ARCOS(AR(5))*GPI
      AR(9)=ARCOS(AR(6))*GPI
100   CONTINUE
      RETURN
      END
      SUBROUTINE SORT(I3)
      COMMON/VS/QP(400),IH(400),IK(400),IL(400)
      MM=I3-1
      DO 20 N=1,MM
      IF(QP(N).LE.QP(N+1))GO TO 20
      J=N+1
15    TT=QP(J)
      ITH=IH(J)
      ITK=IK(J)
      ITL=IL(J)
      QP(J)=QP(J-1)
      IH(J)=IH(J-1)
      IK(J)=IK(J-1)
      IL(J)=IL(J-1)
      QP(J-1)=TT
      IH(J-1)=ITH
      IK(J-1)=ITK
      IL(J-1)=ITL
      J=J-1
      IF(J.LE.1)GO TO 20
      IF(QP(J)-QP(J-1))15,20,20
20    CONTINUE
      RETURN
      END
      SUBROUTINE SORT1(N,ITEM,LM,NMI)
      DIMENSION ITEM(LM),NEST(14,2)
      EQUIVALENCE (L1,POINT2),(L2,KLUFT)
      INTEGER POINT,ALPHA,BETA,POINT1,POINT2
      REAL ITEM,KLUFT,NEST
      IF(N-NMI+1)1,1,2
    1 RETURN
    2 POINT=1
      ALPHA=NMI
      BETA=N
    3 KLUFT=ITEM(BETA)
      POINT1=ALPHA
      POINT2=BETA
    4 IF(ITEM(POINT1).GT.KLUFT) GO TO 7
    5 POINT1=POINT1+1
      IF(POINT1.NE.POINT2) GO TO 4
    6 ITEM(POINT1)=KLUFT
      GO TO 9
    7 ITEM(POINT2)=ITEM(POINT1)
    8 POINT2=POINT2-1
      IF(POINT1.EQ.POINT2) GO TO 6
      IF(ITEM(POINT2).GE.KLUFT) GO TO 8
      ITEM(POINT1)=ITEM(POINT2)
      GO TO 5
    9 L1=POINT1-ALPHA
      L2=BETA-POINT1
      IF(L1.LT.2) GO TO 13
      IF(L2.LT.2) GO TO 16
      IF(L1.GT.L2) GO TO 10
      NEST(POINT,1)=POINT1+1
      NEST(POINT,2)=BETA
      POINT=POINT+1
      GO TO 16
   10 NEST(POINT,1)=ALPHA
      NEST(POINT,2)=POINT1-1
      POINT=POINT+1
   12 ALPHA=POINT1+1
      GO TO 3
   13 IF(L2.GE.2) GO TO 12
      POINT=POINT-1
      IF(POINT.EQ.0) RETURN
      ALPHA=NEST(POINT,1)
      BETA= NEST(POINT,2)
      GO TO 3
   16 BETA=POINT1-1
      GO TO 3
      END
      SUBROUTINE SORT7(N,ITEM,AZ,LM,MM)
      DIMENSION ITEM(LM),AZ(MM,LM),NEST(13,2),A(6)
      REAL KLUFT,ITEM
      INTEGER POINT,ALPHA,BETA,POINT1,POINT2
      IF(N.GE.2)GO TO 2
1     RETURN
2     POINT=1
      ALPHA=1
      BETA=N
3     KLUFT=ITEM(BETA)
      DO 20 I=1,MM
20    A(I)=AZ(I,BETA)
      POINT1=ALPHA
      POINT2=BETA
4     IF(ITEM(POINT1).GT.KLUFT)GO TO 7
5     POINT1=POINT1+1
      IF(POINT1.NE.POINT2)GO TO 4
6     ITEM(POINT1)=KLUFT
      DO 21 I=1,MM
21    AZ(I,POINT1)=A(I)
      GO TO 9
7     ITEM(POINT2)=ITEM(POINT1)
      DO 22 I=1,MM
22    AZ(I,POINT2)=AZ(I,POINT1)
8     POINT2=POINT2-1
      IF(POINT1.EQ.POINT2)GO TO 6
      IF(ITEM(POINT2).GE.KLUFT)GO TO 8
      ITEM(POINT1)=ITEM(POINT2)
      DO 23 I=1,MM
23    AZ(I,POINT1)=AZ(I,POINT2)
      GO TO 5
9     L1=POINT1-ALPHA
      L2=BETA-POINT1
      IF(L1.LT.2)GO TO 13
      IF(L2.LT.2)GO TO 16
      IF(L1.GT.L2)GO TO 10
      NEST(POINT,1)=POINT1+1
      NEST(POINT,2)=BETA
      POINT=POINT+1
      GO TO 16
10    NEST(POINT,1)=ALPHA
      NEST(POINT,2)=POINT1-1
      POINT=POINT+1
12    ALPHA=POINT1+1
      GO TO 3
13    IF(L2.GE.2)GO TO 12
      POINT=POINT-1
      IF(POINT.EQ.0)RETURN
      ALPHA=NEST(POINT,1)
      BETA=NEST(POINT,2)
      GO TO 3
16    BETA=POINT1-1
      GO TO 3
      END
      SUBROUTINE UNAB(Q,R,FEHLP,IZE,VKL,ITA)
      DIMENSION Q(50),DX(100),R(500),IQX(100,12)
      COMMON/LSG/AZ(6,500),VVV(500)
C      EQUIVALENCE (AZ(401),DX(1)),(AZ(901),IQX(1))
      QH=Q(1)*25.
      IF(IZE.EQ.4)QH=Q(1)*36.
      DO 10 J=1,12
      IF(Q(J)-QH)10,11,11
10    CONTINUE
      NE=12
      GO TO 15
11    NE=J-1
      IF(NE.LT.6)NE=6
15    CONTINUE
      CALL ITO(Q,NE,3,3,FEHLP,DX,R,MZ,IQX,IZE,VKL,ITA)
      DO 30 II=1,MZ
      ISA=0
      DO 25 I=1,10
      IF(IQX(II,I).EQ.0)GO TO 27
      ISA=ISA+1
25    CONTINUE
27    IF(ITA.EQ.0)GO TO 30
      WRITE(6,206)DX(II),(IQX(II,I),I=1,ISA)
30    CONTINUE
      IF(MZ.LT.1)GO TO 150
      DZ=2000.
      DO 120 L3=6,NE
      L2M=L3-1
      DO 120 L2=5,L2M
      L1M=L2-1
      DO 120 L1=4,L1M
      DXK=0.
      IU=1
      DO 100 J=1,MZ
      DO 55 K=1,9
      IV=IQX(J,K)
      IF(IV.EQ.3)GO TO 60
      IF(IV-L1)50,60,50
50    IF(IV-L2)51,60,51
51    IF(IV-L3)54,60,54
54    IF(IQX(J,K+2))55,100,55
55    CONTINUE
60    KS=K+1
      DO 70 L=KS,10
      IW=IQX(J,L)
      IF(IW.EQ.3)GO TO 80
      IF(IW-L1)61,80,61
61    IF(IW-L2)62,80,62
62    IF(IW-L3)65,80,65
65    IF(IQX(J,L+1))70,100,70
70    CONTINUE
80    IF(DX(J).GT.DXK)DXK=DX(J)
      IU=-1
100   CONTINUE
      IF(IU)110,110,130
110   IF(DXK-DZ)113,120,120
113   DZ=DXK
      LS1=L1
      LS2=L2
      LS3=L3
      IF(ITA.EQ.0)GO TO 120
      WRITE(6,207)DZ,LS1,LS2,LS3
120   CONTINUE
      L1=LS1
      L2=LS2
      L3=LS3
130   AQ1=Q(L1)
      AQ2=Q(L2)
      AQ3=Q(L3)
      Q(L1)=Q(4)
      Q(L2)=Q(5)
      Q(L3)=Q(6)
      Q(4)=AQ1
      Q(5)=AQ2
      Q(6)=AQ3
150   WRITE(6,201)(Q(I),I=1,6),DZ
201   FORMAT(12H0BASELINES  ,8X,3HQ1=,F8.5,5X,3HQ2=,F8.5,5X,3HQ3=,F8.5
     1,5X,3HQ4=,F8.5,5X,3HQ5=,F8.5,5X,3HQ6=,F8.5,10X,3HDZ=,F4.1/)
206   FORMAT(' DX=',F10.4,10X,'IQX=',10I8)
207   FORMAT(' DZ=',F10.4,10X,'LS =',3I8)
      RETURN
      END
      SUBROUTINE UNOR(MO1,MO2,MC,MCH)
      IMPLICIT INTEGER(H)
      DIMENSION MC(10),F(3),FI(3)
      COMMON FEL(50),Q(50),MMM,LUFM,FEHLP,ITER/QZ/IQ(9),IQN(9)/OR/IM,NNN
      DATA F/1.,4.,9./,FI/1.,0.25,0.1111111/
      DO 10 I=1,9
10    IQN(I)=0
      Q1=Q(1)
      Q2=Q(2)
      AMI=Q1*0.01
      NU1=MO1
      NU2=MO2
C              A+B FESTGELEGT DURCH H1>=K1
      DO 80 H1=1,3
      A=Q1*FI(H1)
C                            BERECHNUNG VON A+B FUER K1=0
      DO 30 K2=1,3
      B=Q2*FI(K2)
      CALL QZO(A,B,-1.,NNN,NU1,NU2,0,INX)
      DO 20 H2=1,3
      B=Q2-A*F(H2)
      B=B*FI(K2)
      IF(B-AMI)30,30,15
15    CALL QZO(A,B,-1.,NNN,NU1,NU2,0,INX)
20    CONTINUE
30    CONTINUE
      HK=H1
      IF(HK.EQ.3)HK=2
      DO 70 K1=1,HK
      K2M=K1+1
C     BERECHNUNG VON A+B FUER H2.EQ.0 + K1.NE.0
      DO 40 K2=K2M,3
      B=Q2*FI(K2)
      A=Q1-B*F(K1)
      A=A*FI(H1)
      IF(A-AMI)40,40,35
35    CALL QZO(A,B,-1.,NNN,NU1,NU2,0,INX)
40    CONTINUE
      DO 50 H2=1,H1
      B=-Q1*F(H2)+Q2*F(H1)
      DO 45 K2=K2M,3
      DELTA=F(H1)*F(K2)-F(H2)*F(K1)
      B=B/DELTA
      IF(B.LT.AMI)GO TO 45
      A=(Q1*F(K2)-Q2*F(K1))/DELTA
      IF(A.LT.AMI)GO TO 45
      CALL QZO(A,B,-1.,NNN,NU1,NU2,0,INX)
45    CONTINUE
50    CONTINUE
      IF(H1-3)52,70,70
52    H2M=H1+1
C                     BERECHNUNG VON A+B FUER H2.GT.H1
      DO 60 H2=H2M,3
      A=Q2*FI(H2)
      B=Q1-A*F(H1)
      IF(B.LT.AMI)GO TO 53
      B=B*FI(K1)
      CALL QZO(A,B,-1.,NNN,NU1,NU2,0,INX)
53    B=-Q1*F(H2)+Q2*F(H1)
      DO 55 K2=1,3
      DELTA=F(H1)*F(K2)-F(H2)*F(K1)
      IF(ABS(DELTA).LT.0.5)GO TO 55
      B=B/DELTA
      IF(B.LT.AMI)GO TO 55
      A=(Q1*F(K2)-Q2*F(K1))/DELTA
      IF(A.LT.AMI)GO TO 55
      CALL QZO(A,B,-1.,NNN,NU1,NU2,0,INX)
55    CONTINUE
60    CONTINUE
70    CONTINUE
80    CONTINUE
      IF(INX-NU2+NU1-1)85,84,84
84    WRITE(6,500)NU2
      MCH=2
      MC(1)=NU2-1
      MC(2)=NU2
      RETURN
85    DO 90 J=NU1,NU2
      IF(IQN(J))90,88,90
88    MCH=1
      MC(1)=J
      RETURN
90    CONTINUE
      DO 100 J=1,INX
      JJ=IQ(J)
      IF(IQN(JJ).EQ.1)GO TO 110
100   CONTINUE
      J1=0
      J2=NU1-1
102   J1=J1+1
      J2=J2+1
      MC(J1)=J2
      IF(J2-NU2)102,103,103
103   CONTINUE
      MCH=J1
      RETURN
110   DO 116  J=NU1,NU2
      DO 114 L=1,INX
      IF(IQ(L).EQ.J)GO TO 116
114   CONTINUE
      MCH=2
      MC(1)=JJ
      MC(2)=J
      GO TO 120
116   CONTINUE
120   CONTINUE
500   FORMAT(1H0,9HTHE FIRST,I2,51H D-VALUES CAN BE ASSIGNED TO A COMMON
     + LATTICE PLANE)
      RETURN
      END
      SUBROUTINE UNMON(Q,FEHLS,W,IRUN)
      REAL K1,K2
      DIMENSION  HK(2,30),H2(30),K2(30),WK(10),
     +Q(50), G1(3), G2(3),RA(9),IHY(9)
      DIMENSION IG(84)
      COMMON /QUAD/IG
      DATA  G1/1.,.25,1./,G2/1.,1.,.25/
      DATA  HK/ 1.,0.,1.,0.,1.,0.,1.,0.,1.,0.,1.,0.,1.,0.,1.,0.
     A,4.,0.,4.,0.,4.,0.,4.,0.,4.,0.,4.,0.,4.,0.,4.,0., 10*1., 4.,1.,
     B 4.,1.,4.,1.,4.,1.,4.,1.,4.,1., 4.,2.,4.,2.,4.,2./
      DATA H2/0.,1.,4.,9.,0.,1.,4.,9.,0.,1.,4.,9.,0.,1.,4.,9.,
     A 4.,9.,4.,9.,3*9.,0.,1.,4.,4*9./
      DATA K2/4*1.,4*4.,4*1.,4*4.,0.,0.,1.,1.,4.,0.,1.,4*4.,0.,1.,4./
      DATA PI4,PI2/0.7854,1.5708/
      KZ=0
      FEHL=FEHLS
      IF(IRUN.LE.0)GO TO 20
      IF(Q(5).GT.Q(1))GO   TO 4
      QZW=Q(5)
      Q(5)=Q(12)
      Q(12)=QZW
4     CONTINUE
      CALL SORT1(11,Q,50,1)
      NS=11
      DO 5 I=3,10
      IF(ABS(Q(I)-QS).LE.0.0000001)NS=I
5     CONTINUE
      GO TO 20
10    CONTINUE
C     MINDESTENS 6 DER ERSTEN 9  LINIEN LIEGEN AUF RECHTECKNETZ
C     Q(1) WIRD AUS BASISLISTE GESTRICHEN
      DO 11 I=1,IHZ
      IY=IHY(I)
11    RA(I)=Q(IY)
      WRITE(6,2000)Q(1),Q(2),(RA(I),I=1,IHZ)
      WRITE(6,2001)A,B
      KZ=1
      QZW=Q(1)
      DO 12 I=1,11
12    Q(I)=Q(I+1)
      Q(12)=QZW
      FEHL=FEHL/1.5
20    CONTINUE
C     ERSTELLEN VON RECHTECKNETZEN ZU DEN ERSTEN BEIDEN Q-WERTEN
      KX=1
      KY=2
      KS=3
      DO 25 I=1,9
      WK(I)=1.
25    RA(I)=1.
      Q12=1./(Q(1)*Q(2))
      DO 52 KW=1,3
      Q1=Q(KX)
      Q2=Q(KY)
      DO 50 J= 1,30
      H1=HK(1,J)
      K1=HK(2,J)
      DE=H1*K2(J)-H2(J)*K1
      DE=1./DE
      A=(K2(J)*Q1-K1*Q2)*DE
      B=(-H2(J)*Q1+H1*Q2)*DE
      IF(A.LE.0..OR.B.LE.0.)GO TO 50
      IF (B.GT.A)GO TO 30
      C=A
      A=B
      B=C
30    CONTINUE
      AI=1./A
      X=B*AI
C     INDIZIERUNG DER Q-WERTE  Q3....Q8  IN DEN 30 RECHTECKNETZEN
C     ZUORDNUNG VON  RANGWERTEN JE NACH NETZART BEI ERFOLGREICHER INDIZ
      IHZ=0
      AB2=(A+B)*0.5
      REI=1./SQRT(A*B)
      PIF=PI4*REI
      ABF=AB2*REI
      PR=1.
      RE=A*B*Q12
      DO 41 K=KS,9
      EPS =Q(K)*FEHL
      EPS2=EPS+EPS
      QQ=Q(K)+EPS
      EP=EPS2*AI
      F=QQ*AI+2.
      IF(F.GE.81.)GO TO 41
      S=1.
35    CONTINUE
      F2=F-EP
      I2=MAX0(F2,1)
      I1=F
      IF(IG(I1)-IG(I2))38,36,38
36    F=F-X*S
      S=S+2.
      IF(F-2.)41,35,35
38    CONTINUE
      PRK=EPS*(PIF+ABF/SQRT(Q(K)))
      PR=PR*(1.-PRK)/PRK
      IHZ=IHZ+1
      IHY(IHZ)=K
41    CONTINUE
      IF(IHZ.LE.0)GO TO 50
      IF(IRUN.LE.0)GO TO 44
      DO 43 I=1,IHZ
      IF(IHY(I).EQ.NS)GO TO 44
43    CONTINUE
      GO TO 50
44    CONTINUE
      PR=PR*RE
      DO 45 I=1,IHZ
      IY=IHY(I)
      IF(PR.GT.RA(IY))RA(IY)=PR
45    CONTINUE
      IF(IHZ.LT.6)GO TO 50
      IF(KZ.LE.0)GO TO 10
      IF(IHZ.EQ.6)GO TO 56
      QZW=Q(3)
      Q(3)=Q(8)
      Q(8)=QZW
      IR=3
      GO TO 59
50    CONTINUE
      IF(KW.NE.1)GO TO 51
56    CONTINUE
      LAR=3
      ARA=RA(3)
      DO 58 I=4,9
      IF(RA(I).GE.ARA)GO TO 58
      LAR=I
      ARA=RA(I)
58    CONTINUE
      RZW=RA(3)
      QZW=Q(3)
      Q(3)=Q(LAR)
      RA(3)=RA(LAR)
      Q(LAR)=QZW
      RA(LAR)=RZW
      IF(IHZ.LT.6)GO TO 51
      IR=4
59    WRITE(6,2000)(Q(I),I=IR,9)
      WRITE(6,2001)A,B
      J=9
      RAM=RA(9)
      GO TO 110
51    CONTINUE
      KS=4
      IF(KY.EQ.3)KX=2
      IF(KY.NE.3)KY=3
52    CONTINUE
      Q1=Q(1)
      Q2=Q(2)
      RA(1)=-3.
      RA(2)=-2.
C     ERMITTLUNG DES GUENSTIGSTEN Q-WERTES QX
C     ERSTELLUNG SCHIEFWINKELIGER NETZE ZU DEN Q-WERTEN Q1,Q2,QX.
C         M=0
      DO 70 J=1,3
      AA=Q1*G1(J)
      BB=Q2*G2(J)
      SK=0.
60    SK=SK+1.
      Y=Q(3)-BB*SK*SK
      SH=0.
62    SH=SH+1.
      A=AA
      B=BB
      D=(Y-AA*SH*SH)/(SH*SK)
      Z=A*B-0.25*D*D
      IF(Z.LE.0.)GO TO 71
C     REDUKTION DES EBENEN GITTERS
      D=ABS(D)
64    IF(A-B)66,66,65
65    X=A
      A=B
      B=X
66    IF(A-D)67,69,69
67    B=B-D+A
      D=ABS(D-2.*A)
      GO TO 64
69    CONTINUE
C     INDIZIERUNG DER Q-WERTE Q4...Q8 MIT DEN     SCHIEFW. NETZEN.
      PR=1.
      IHZ=0
      REI=1./SQRT(Z)
      PIF=PI2*REI
      ABF=(A+B)*0.5*REI
      DO 95 K=4,9
      QQ=Q(K)
      EPS=FEHL*QQ
      QS=QQ+EPS
      IF(Z*625.0.LT.QS*QS)GO TO 95
      EPS2=EPS+EPS
      F=QS
C      FK2M=F*A/Z
      FK=0.
77    CONTINUE
      F1=F-B*FK*FK
      IF(F1)89,78,78
78    IF(F1-EPS2)97,97,79
79    F2=D*FK
      F3=F2
      H=1.
80    CONTINUE
      F6=F1-A*H*H-F3
      IF(F6)84,81,81
81    IF(F6-EPS2)97,97,82
82    H=H+1.
      F3=F3+F2
      GO TO 80
84    IF(F2)87,87,85
85    F3=-F3
      F2=-F2
      GO TO 80
87    FK=FK+1.
      GO  TO 77
89    IF(F-Z/A*FK*FK)95,95,90
90    F6=F1
      H=0.
91    H=H+1.
      F7=F1+(D*FK-A*H)*H
      IF(F7.LT.F6.AND.F6.LT.0.)GO TO 87
      F6=F7
      IF(F6)91,97,92
92    IF(F6-EPS2)97,97,91
C     ZUORDNUNG VON WAHRSCHEINLICHKEITSWERTEN FUER ERFOLGREICHE INDIZ.
97    CONTINUE
      PRK=EPS*(PIF+ABF/SQRT(QQ  ))
      PR=PR*(1.-PRK)/PRK
      IHZ=IHZ+1
      IHY(IHZ)=K
95    CONTINUE
      IF(IHZ.LE.0)GO TO 100
      PR=PR*Z*Q12
      DO 98 I=1,IHZ
      IY=IHY(I)
      IF(PR.GT.WK(IY))WK(IY)=PR
98    CONTINUE
100   CONTINUE
71    CONTINUE
      IF(SH.LT.2.9)GOTO 62
      IF(SK.LT.2.9)GOTO 60
70    CONTINUE
      DO 105 J=4,9
105   RA(J)=RA(J)+WK(J)
      RAM=RA(4)
      J=4
      DO 108 I=5,9
      IF(RA(I)-RAM)107,108,108
107   RAM=RA(I)
      J=I
108   CONTINUE
110   CONTINUE
      X=Q(4)
      Q(4)=Q(J)
      Q(J)=X
      QS=Q(4)
      W=RAM+RA(3)
      W=ALOG(W)
      CALL SORT1(4,Q,50,1)
2000  FORMAT(79H0THE LINES WITH FOLLOWING Q-VALUES CAN BE ASSIGNED TO A
     1COMMON RECTANGULAR NET  /5X,10F10.5)
2001  FORMAT(26H RECIPROCAL NET PARAMETERS,10X,2HA=,F10.6,5X,2HB=,F10.6)
      RETURN
      END
      SUBROUTINE VGR(QN,V1Z,VD1Z,NZMAX,VM,FEHL,ISYS,VK,VG,JV)
      DIMENSION  VG(10),VK(10),FF(6)
      DATA FF/0.15,0.22,0.53,1.05,2.1,2.1/
      FA=4.
      IF(ISYS.LE.4)FA=6.
      VH=FA*20./(QN*SQRT(QN)*FF(ISYS))
      IF(V1Z.GT.0.)GO TO 10
      VMI=VM
      VMA=VH
      NZMI=1
      NZMA=1
      GO TO 11
10    VD=VD1Z+1.5*V1Z*FEHL
      VMI=V1Z-VD
      VMA=V1Z+VD
      ZMI=VM/VMA
      NZMI=ZMI+1.
      L=NZMAX-NZMI+1
      IF(L.GT.10)NZMAX=10+NZMI-1
      NZMA=VH/VMI
      IF(NZMA.GT.NZMAX)NZMA=NZMAX
11    CONTINUE
      JV=NZMA-NZMI+1
      J=JV+1
      WRITE(6,200)
      DO 12 I=NZMI,NZMA
      BI=I
      J=J-1
      V1=BI*VMI
      V2=BI*VMA
      WRITE(6,201)V1,V2
      VK(J)=1./V2**2
12    VG(J)=1./V1**2
200   FORMAT(1H0,14H VOLUME RANGES)
201   FORMAT(1X,F15.3,6H .....,F9.3)
      RETURN
      END
      SUBROUTINE VERG(IDA,IOR)
      REAL IQW,I20
      DIMENSION AR(9),Q(50),AK(6),AKM(6),P(50),F(50,6),E(50,6),
     1HX(4,2),KX(4,2),LX(4,2),IRE(4),PP(50)
      COMMON FEL(50),QAN(50),NNN,LUFM,FEP,ITER/SCHR/TEXT(20),IQW,I20,NQW
     1,ITEST,QN,WLENG
     1/LSG/AZ(6,500),VVV(500)
     1/VQ/PF(50),LH(50),LK(50),LL(50),PF2(50)
     1,LH2(50),LK2(50),LL2(50),PFA(50)/VS/QP(400),IH(400),IK(400)
     2,IL(400)/CQS/QS(2)
      COMMON /BEST/WMB
      INTEGER H1
      GPI=360./3.141592654
      WRITE(6,206)IDA
      IDS1=6
      IDS2=2
      WMS1=0
      WMS2=0.
C      MMAX=20
C      IF(NNN.LT.20)MMAX=NNN
      DO 5 I=1,IOR
      Q(I)=QAN(I)
5     PFA(I)=-100000.
      IF(IOR.LE.4)GO TO 4
      Q(1)=QS(1)
      Q(2)=QS(2)
4     CONTINUE
      IORE=IOR+1
      DO 10 I=IORE,NNN
      Q(I)=QAN(I)
10    PFA(I)=-10000.
      QWF=QN
      CALL SORT7(NNN,Q,PFA,50,1)
      QRZ=1.1*Q(NNN)
      IF(ITEST.EQ.0)GO TO 25
      WRITE(6,221)
      DO 20 I=1,IDA
      VOL=1./VVV(I)
      VOL=SQRT(VOL)
20    WRITE(6,201)(AZ(J,I),J=1,6),VOL
25    CONTINUE
      DO 180 ID=1,IDA
      FEHLP=FEP
      IT=1
      IREAL=1
      J1=6
      AA1=AZ(1,ID)
      IF(AA1.EQ.0)GO TO 180
      AA2=AZ(2,ID)
      AA3=AZ(3,ID)
      AA4=AZ(4,ID)
      AA5=AZ(5,ID)
      AA6=AZ(6,ID)
      A1=AA1
      A2=AA2
      A3=AA3
      A4=AA4
      A5=AA5
      A6=AA6
30    CONTINUE
      DO 40 I=1,NNN
40    FEL(I)=Q(I)*FEHLP
      CALL QERZ(A1,A2,A3,A4,A5,A6,QRZ,399,MONO,Q,NNN,P,IRM,1,1,IW,QWF,
     1IV)
      IF(IRM.LT.J1.AND.IT.GT.1)GO TO 88
      JF=0
      DO 46J=1,IRM
      IF(PF2(J)+99.)45,46,46
45    JF=JF+1
46    CONTINUE
      J=0
      IF(IRM-J1)50,50,48
48    J1=IRM
      AMV=1000000.
50    CONTINUE
C                 NLG=JF
      JAZ=0
      IF(JF-4)86,86,54
54    DO 57 JS=1,IRM
      IF(PF2(JS)+99.)56,57,57
56    CONTINUE
      J=J+1
      H1=LH(JS)
      K1=LK(JS)
      L1=LL(JS)
      F(J,1)=H1**2
      F(J,2)=K1**2
      F(J,3)=L1**2
      F(J,4)=H1*K1
      F(J,5)=K1*L1
      F(J,6)=L1*H1
      PP(J)=P(JS)
57    CONTINUE
      IF(JF.LE.8)GO TO 105
61    CONTINUE
      CALL MAUS(PP,F,IOR,J,AK,AKM,VT1,AM)
      JAF=0
      IF(J.LT.0)GO TO 60
      A1=AK(1)
      A2=AK(2)
      A3=AK(3)
      A4=AK(4)
      A5=AK(5)
      A6=AK(6)
62    CONTINUE
      CALL QERZ(A1,A2,A3,A4,A5,A6,QRZ,399,MON ,Q,NNN,P,IRM,1,1,IW,QWF,
     1IV)
63     CONTINUE
      IF(IRM.GE.J1)GO TO 64
60    IF(JAZ.GT.0.AND.JAZ.LT.JVG)GO TO 135
      IF(JAF.GT.0)GO TO 88
      JAF=1
      A1=AA1
      A2=AA2
      A3=AA3
      A4=AA4
      A5=AA5
      A6=AA6
      GO TO 62
64    CONTINUE
      DO 69 I=1,IRM
      H1=LH(I)
      K1=LK(I)
      L1=LL(I)
      E(I,1)=H1**2
      E(I,2)=K1**2
      E(I,3)=L1**2
      E(I,4)=H1*K1
      E(I,5)=K1*L1
      E(I,6)=L1*H1
69    CONTINUE
      J=IRM
      CALL MAUS(P,E,MON,J,AK,AKM,VT1,AM)
      IF(MON-4)72,72,74
72    AM=0.5*AM
74    IF(AM-AMV)75,78,78
75    IF(J.LT.J1)GO TO 78
      AMV=AM
      AA1=AK(1)
      AA2=AK(2)
      AA3=AK(3)
      AA4=AK(4)
      AA5=AK(5)
      AA6=AK(6)
78    IF(JAZ.GT.0)GO TO 135
79    CONTINUE
      A1=AA1
      A2=AA2
      A3=AA3
      A4=AA4
      A5=AA5
      A6=AA6
      IF(IT-ITER)86,88,88
86    FEHLP=FEHLP*0.8
      IT=IT+1
      GO TO 30
88    CONTINUE
      CALL QERZ(A1,A2,A3,A4,A5,A6,QRZ,399,MON ,Q,NNN,P,IRM,2,1,IW,QWF,
     1IV)
      BMV=0.
      DO 92 I=1,IRM
92    BMV=BMV+PF(I)
      BMV=BMV/IRM
      WM20=QWF/(2.*BMV*IV)
      IF(WM20.LT.IQW)GO TO 180
      AZ(1,ID)=A1
      AZ(2,ID)=A2
      AZ(3,ID)=A3
      AZ(4,ID)=A4
      AZ(5,ID)=A5
      AZ(6,ID)=A6
      DO 90 I=1,6
      IF(ABS(AZ(I,ID)-AZ(I,IDS1)).GT.ABS(AZ(I,ID)*0.02))GO TO 91
90    CONTINUE
      IF(WM20.LE.WMS1*1.005)GO TO 180
91    DO 93 I=1,6
      IF(ABS(AZ(I,ID)-AZ(I,IDS2)).GT.ABS(AZ(I,ID)*0.02))GO TO 94
93    CONTINUE
      IF(WM20.LE.WMS2*1.005)GO TO 180
94    CONTINUE
      IDS1=IDS2
      IDS2=ID
      WMS1=WMS2
      WMS2=WM20
      IF(WM20.GT.WMB)WMB=WM20
      IREAL=-2
      CALL REZE(A1,A2,A3,A4,A5,A6,AR,VOL,IREAL)
      IF(VOL.LE.0.)GO TO 180
      WRITE(6,205)
      VOL2=SQRT(VOL)
      WRITE(6,202)(AR(I),I=1,3),(AR(I),I=7,9),VOL2,AMV,WM20,IV
      IF(WM20.LT.I20)GO TO 180
      WRITE(6,230)
      ISC=1
      DO 95 I=1,IRM
      DO 96 ISD=ISC,NNN
      IF(P(I).EQ.Q(ISD))GO TO 99
      DWE=1./SQRT(Q(ISD))
      WRITE(6,228)DWE,Q(ISD)
96    CONTINUE
99    CONTINUE
      ISC=ISD+1
      IF(MON.LE.3)LH(I)=IABS(LH(I))
      DWE=1./SQRT(P(I))
      WRITE(6,229)I,DWE,P(I),PF(I),LH(I),LK(I),LL(I)
      IF(WLENG.LE.0.)GO TO 95
      QC=A1*LH(I)**2+A2*LK(I)**2+A3*LL(I)**2+A4*LH(I)*LK(I)
     1+A5*LK(I)*LL(I)+A6*LL(I)*LH(I)
      THETAC=ASIN(WLENG*SQRT(QC)*0.5)*GPI
      THETAO=ASIN(WLENG*SQRT(P(I))*0.5)*GPI
      DELTHE=THETAO-THETAC
      WRITE(6,231)THETAO,DELTHE
95    CONTINUE
      CALL SORT(IW)
      IF(MON.GE.4)GO TO 98
      DO 97 I=1,NQW
97    IH(I)=IABS(IH(I))
98    CONTINUE
      PRINT 216
      WRITE(6,227)
      IPS=(NQW+4)/5
      DO 100 J=1,IPS
      J1=J+IPS
      J2=J+2*IPS
      J3=J+3*IPS
      J4=J+4*IPS
      WRITE(6,217)QP(J),IH(J),IK(J),IL(J),QP(J1),IH(J1),IK(J1),IL(J1),
     1QP(J2),IH(J2),IK(J2),IL(J2),QP(J3),IH(J3),IK(J3),IL(J3),
     2QP(J4),IH(J4),IK(J4),IL(J4)
100   CONTINUE
      GO TO 180
105   CONTINUE
      JF9=9-JF
      JVG=2**JF9
      DO 110 I=1,JF9
110   IRE(I)=1
      JAZ=0
      JWM=IRM+1
      JT=1
      DO 130 JW=1,IRM
      JS=JWM-JW
      IF(PF2(JS))130,130,120
120   CONTINUE
      IB=JF+JT
      PP(IB)=P(JS)
      HX(JT,1)=LH(JS)
      KX(JT,1)=LK(JS)
      LX(JT,1)=LL(JS)
      HX(JT,2)=LH2(JS)
      KX(JT,2)=LK2(JS)
      LX(JT,2)=LL2(JS)
      JT=JT+1
      IF(JT-JF9)130,130,135
130   CONTINUE
C                   NLG=-JF
      MON=MONO
      GO TO 63
135   CONTINUE
      JAZ=JAZ+1
      IF(JAZ.GT.JVG)GO TO 79
      DO 160 JT=1,JF9
      IR=IRE(JT)
      H1=HX(JT,IR)
      K1=KX(JT,IR)
      L1=LX(JT,IR)
      IB=JF+JT
      F(IB,1)=H1**2
      F(IB,2)=K1**2
      F(IB,3)=L1**2
      F(IB,4)=H1*K1
      F(IB,5)=K1*L1
      F(IB,6)=L1*H1
160   CONTINUE
      DO 149 I=1,JF9
      IF(IRE(I)-1)142,142,145
142   IRE(I)=2
      GO TO 151
145   IRE(I)=1
149   CONTINUE
151   CONTINUE
      J=9
      GO TO 61
180   CONTINUE
201   FORMAT(1X,6E16.6,E20.6)
202   FORMAT(1X,3F12.5,2X,3F10.2,F13.2,F16.8,F10.1,I9)
205   FORMAT(/,1H0,7X,1HA,11X,1HB,11X,1HC,11X,5HALPHA,5X,4HBETA,6X
     1,5HGAMMA,6X,7HVOLUME ,4X,13HSTANDARD DEV.,6X,3HM20,6X,3HN20)
206   FORMAT(20H0NUMBER OF SOLUTIONS,I6)
216   FORMAT(43H0ORDERED Q-VALUES OF THE CALCULATED LATTICE)
217   FORMAT(1X,5(F15.6,3X,3I2,1X))
221   FORMAT(1H0,7X,2HA1,14X,2HA2,14X,2HA3,14X,2HA4,14X,2HA5,14X,2HA6)
227   FORMAT(1H0,5(9X,1HQ,9X,1HH,2H K,3H L ))
228   FORMAT(F13.3,F11.5)
229   FORMAT(1X,I3,F9.3,2F11.5,2X,3I4)
230   FORMAT(1H0,7X,5HD-OBS,5X,5HQ-OBS,5X,7H/QO-QC/,4X,9HH   K   L ,
     17X,8H2*THETAO,3X,11H2*(THO-THC))
231   FORMAT(1H+,50X,2F11.3)
      RETURN
      END
      FUNCTION SECOND(T)
      SECOND=0.
      RETURN
      END
